/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.animation.AnimatorListenerAdapter
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.animation');

/**
 * @class android.animation.AnimatorListenerAdapter
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html}
 **/
var AnimatorListenerAdapter = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.animation.AnimatorListenerAdapter')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.animation.AnimatorListenerAdapter. Create a subclass using android.animation.AnimatorListenerAdapter.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AnimatorListenerAdapter.prototype = Object.create(SuperClass.prototype);
AnimatorListenerAdapter.prototype.constructor = AnimatorListenerAdapter;

Object.defineProperty(AnimatorListenerAdapter.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AnimatorListenerAdapter(this.$native.super);
	},
	enumerable: true
});

AnimatorListenerAdapter.className = 'android.animation.AnimatorListenerAdapter';
AnimatorListenerAdapter.prototype.className = 'android.animation.AnimatorListenerAdapter';

// class property
Object.defineProperty(AnimatorListenerAdapter, 'class', {
	get: function() {
		return Hyperloop.getClass('android.animation.AnimatorListenerAdapter');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AnimatorListenerAdapter.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.animation.AnimatorListenerAdapter');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AnimatorListenerAdapter.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AnimatorListenerAdapter.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AnimatorListenerAdapter(Hyperloop.cast('android.animation.AnimatorListenerAdapter', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onAnimationPause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html#onAnimationPause(android.animation.Animator)}
 **/
AnimatorListenerAdapter.prototype.onAnimationPause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationPause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.animation.AnimatorListenerAdapter') {
			return new AnimatorListenerAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationCancel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html#onAnimationCancel(android.animation.Animator)}
 **/
AnimatorListenerAdapter.prototype.onAnimationCancel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationCancel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.animation.AnimatorListenerAdapter') {
			return new AnimatorListenerAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationRepeat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html#onAnimationRepeat(android.animation.Animator)}
 **/
AnimatorListenerAdapter.prototype.onAnimationRepeat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationRepeat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.animation.AnimatorListenerAdapter') {
			return new AnimatorListenerAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html#onAnimationResume(android.animation.Animator)}
 **/
AnimatorListenerAdapter.prototype.onAnimationResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.animation.AnimatorListenerAdapter') {
			return new AnimatorListenerAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html#onAnimationEnd(android.animation.Animator)}
 **/
AnimatorListenerAdapter.prototype.onAnimationEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.animation.AnimatorListenerAdapter') {
			return new AnimatorListenerAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/animation/AnimatorListenerAdapter.html#onAnimationStart(android.animation.Animator)}
 **/
AnimatorListenerAdapter.prototype.onAnimationStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.animation.AnimatorListenerAdapter') {
			return new AnimatorListenerAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AnimatorListenerAdapter;
