/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module XmlResourceParser
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.content.res');

/**
 * constructor
 * http://developer.android.com/reference/android/content/res/XmlResourceParser.html
 **/
var XmlResourceParser = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.content.res.XmlResourceParser') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.content.res.XmlResourceParser');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
XmlResourceParser.prototype = Object.create(SuperClass.prototype);
XmlResourceParser.prototype.constructor = XmlResourceParser;

Object.defineProperty(XmlResourceParser.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new XmlResourceParser(this.$native.super);
	},
	enumerable: true
});

XmlResourceParser.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

XmlResourceParser.className = "android.content.res.XmlResourceParser";
XmlResourceParser.prototype.className = "android.content.res.XmlResourceParser";

// class property
Object.defineProperty(XmlResourceParser, 'class', {
	get: function() {
		return Hyperloop.getClass('android.content.res.XmlResourceParser');
	},
	enumerable: true,
	configurable: false
});

// Cast
XmlResourceParser.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new XmlResourceParser(Hyperloop.cast('android.content.res.XmlResourceParser', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function getAttributeType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeType(int)}
 **/
XmlResourceParser.prototype.getAttributeType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function next
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#next()}
 **/
XmlResourceParser.prototype.next = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'next',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDepth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getDepth()}
 **/
XmlResourceParser.prototype.getDepth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDepth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getName()}
 **/
XmlResourceParser.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeValue(int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeValue(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeValue(int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeValue(java.lang.String, java.lang.String)}
 **/
XmlResourceParser.prototype.getAttributeValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespaceCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getNamespaceCount(int)}
 **/
XmlResourceParser.prototype.getNamespaceCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespaceCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIdAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getIdAttribute()}
 **/
XmlResourceParser.prototype.getIdAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIdAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeFloatValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeFloatValue(java.lang.String, java.lang.String, float)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeFloatValue(int, float)}
 **/
XmlResourceParser.prototype.getAttributeFloatValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeFloatValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIdAttributeResourceValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getIdAttributeResourceValue(int)}
 **/
XmlResourceParser.prototype.getIdAttributeResourceValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIdAttributeResourceValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeNameResource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeNameResource(int)}
 **/
XmlResourceParser.prototype.getAttributeNameResource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeNameResource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeResourceValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeResourceValue(java.lang.String, java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeResourceValue(int, int)}
 **/
XmlResourceParser.prototype.getAttributeResourceValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeResourceValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTextCharacters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getTextCharacters(int[])}
 **/
XmlResourceParser.prototype.getTextCharacters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextCharacters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeBooleanValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeBooleanValue(java.lang.String, java.lang.String, boolean)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeBooleanValue(int, boolean)}
 **/
XmlResourceParser.prototype.getAttributeBooleanValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeBooleanValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#setFeature(java.lang.String, boolean)}
 **/
XmlResourceParser.prototype.setFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespacePrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getNamespacePrefix(int)}
 **/
XmlResourceParser.prototype.getNamespacePrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespacePrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeUnsignedIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeUnsignedIntValue(java.lang.String, java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeUnsignedIntValue(int, int)}
 **/
XmlResourceParser.prototype.getAttributeUnsignedIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeUnsignedIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPositionDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getPositionDescription()}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getPositionDescription()}
 **/
XmlResourceParser.prototype.getPositionDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPositionDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#close()}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#close()}
 **/
XmlResourceParser.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getClassAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getClassAttribute()}
 **/
XmlResourceParser.prototype.getClassAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClassAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isAttributeDefault
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#isAttributeDefault(int)}
 **/
XmlResourceParser.prototype.isAttributeDefault = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAttributeDefault',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributePrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributePrefix(int)}
 **/
XmlResourceParser.prototype.getAttributePrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributePrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getStyleAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getStyleAttribute()}
 **/
XmlResourceParser.prototype.getStyleAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStyleAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getProperty(java.lang.String)}
 **/
XmlResourceParser.prototype.getProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getPrefix()}
 **/
XmlResourceParser.prototype.getPrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeListValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeListValue(java.lang.String, java.lang.String, java.lang.String[], int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeListValue(int, java.lang.String[], int)}
 **/
XmlResourceParser.prototype.getAttributeListValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeListValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getText()}
 **/
XmlResourceParser.prototype.getText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#nextText()}
 **/
XmlResourceParser.prototype.nextText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function defineEntityReplacementText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#defineEntityReplacementText(java.lang.String, java.lang.String)}
 **/
XmlResourceParser.prototype.defineEntityReplacementText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'defineEntityReplacementText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getColumnNumber
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getColumnNumber()}
 **/
XmlResourceParser.prototype.getColumnNumber = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnNumber',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getInputEncoding
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getInputEncoding()}
 **/
XmlResourceParser.prototype.getInputEncoding = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInputEncoding',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function require
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#require(int, java.lang.String, java.lang.String)}
 **/
XmlResourceParser.prototype.require = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'require',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isWhitespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#isWhitespace()}
 **/
XmlResourceParser.prototype.isWhitespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWhitespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeCount()}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeCount()}
 **/
XmlResourceParser.prototype.getAttributeCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeName(int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeName(int)}
 **/
XmlResourceParser.prototype.getAttributeName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeIntValue(java.lang.String, java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeIntValue(int, int)}
 **/
XmlResourceParser.prototype.getAttributeIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getFeature(java.lang.String)}
 **/
XmlResourceParser.prototype.getFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setInput
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#setInput(java.io.Reader)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#setInput(java.io.InputStream, java.lang.String)}
 **/
XmlResourceParser.prototype.setInput = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInput',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#nextTag()}
 **/
XmlResourceParser.prototype.nextTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getLineNumber
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getLineNumber()}
 **/
XmlResourceParser.prototype.getLineNumber = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLineNumber',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getEventType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getEventType()}
 **/
XmlResourceParser.prototype.getEventType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isEmptyElementTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#isEmptyElementTag()}
 **/
XmlResourceParser.prototype.isEmptyElementTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEmptyElementTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getNamespace(java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getNamespace()}
 **/
XmlResourceParser.prototype.getNamespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextToken
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#nextToken()}
 **/
XmlResourceParser.prototype.nextToken = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextToken',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#setProperty(java.lang.String, java.lang.Object)}
 **/
XmlResourceParser.prototype.setProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespaceUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getNamespaceUri(int)}
 **/
XmlResourceParser.prototype.getNamespaceUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespaceUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeNamespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/res/XmlResourceParser.html#getAttributeNamespace(int)}
 **/
XmlResourceParser.prototype.getAttributeNamespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeNamespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.res.XmlResourceParser') {
			return new XmlResourceParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

XmlResourceParser.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

XmlResourceParser.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = XmlResourceParser;
