/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Cursor
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.database');

/**
 * constructor
 * http://developer.android.com/reference/android/database/Cursor.html
 **/
var Cursor = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.database.Cursor') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.database.Cursor');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Cursor.prototype = Object.create(SuperClass.prototype);
Cursor.prototype.constructor = Cursor;

Object.defineProperty(Cursor.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Cursor(this.$native.super);
	},
	enumerable: true
});

Cursor.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Cursor.className = "android.database.Cursor";
Cursor.prototype.className = "android.database.Cursor";

// class property
Object.defineProperty(Cursor, 'class', {
	get: function() {
		return Hyperloop.getClass('android.database.Cursor');
	},
	enumerable: true,
	configurable: false
});

// Cast
Cursor.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Cursor(Hyperloop.cast('android.database.Cursor', object.$native));
};

// Constants
// http://developer.android.com/reference/android/database/Cursor.html#FIELD_TYPE_FLOAT
Cursor.FIELD_TYPE_FLOAT = 2;
// http://developer.android.com/reference/android/database/Cursor.html#FIELD_TYPE_INTEGER
Cursor.FIELD_TYPE_INTEGER = 1;
// http://developer.android.com/reference/android/database/Cursor.html#FIELD_TYPE_BLOB
Cursor.FIELD_TYPE_BLOB = 4;
// http://developer.android.com/reference/android/database/Cursor.html#FIELD_TYPE_NULL
Cursor.FIELD_TYPE_NULL = 0;
// http://developer.android.com/reference/android/database/Cursor.html#FIELD_TYPE_STRING
Cursor.FIELD_TYPE_STRING = 3;

// Static methods

// Instance methods
/**
 * @function getColumnNames
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getColumnNames()}
 **/
Cursor.prototype.getColumnNames = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnNames',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setNotificationUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#setNotificationUri(android.content.ContentResolver, android.net.Uri)}
 **/
Cursor.prototype.setNotificationUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setNotificationUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isLast
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#isLast()}
 **/
Cursor.prototype.isLast = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLast',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getColumnName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getColumnName(int)}
 **/
Cursor.prototype.getColumnName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getDouble(int)}
 **/
Cursor.prototype.getDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function moveToLast
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#moveToLast()}
 **/
Cursor.prototype.moveToLast = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'moveToLast',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getFloat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getFloat(int)}
 **/
Cursor.prototype.getFloat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFloat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function moveToPrevious
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#moveToPrevious()}
 **/
Cursor.prototype.moveToPrevious = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'moveToPrevious',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function registerDataSetObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#registerDataSetObserver(android.database.DataSetObserver)}
 **/
Cursor.prototype.registerDataSetObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerDataSetObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function deactivate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#deactivate()}
 **/
Cursor.prototype.deactivate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'deactivate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isFirst
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#isFirst()}
 **/
Cursor.prototype.isFirst = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFirst',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setExtras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#setExtras(android.os.Bundle)}
 **/
Cursor.prototype.setExtras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setExtras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function moveToNext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#moveToNext()}
 **/
Cursor.prototype.moveToNext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'moveToNext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function unregisterDataSetObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#unregisterDataSetObserver(android.database.DataSetObserver)}
 **/
Cursor.prototype.unregisterDataSetObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterDataSetObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getWantsAllOnMoveCalls
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getWantsAllOnMoveCalls()}
 **/
Cursor.prototype.getWantsAllOnMoveCalls = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWantsAllOnMoveCalls',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getExtras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getExtras()}
 **/
Cursor.prototype.getExtras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getCount()}
 **/
Cursor.prototype.getCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#close()}
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#close()}
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#close()}
 **/
Cursor.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function move
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#move(int)}
 **/
Cursor.prototype.move = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'move',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function unregisterContentObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#unregisterContentObserver(android.database.ContentObserver)}
 **/
Cursor.prototype.unregisterContentObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterContentObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getShort
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getShort(int)}
 **/
Cursor.prototype.getShort = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getShort',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isBeforeFirst
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#isBeforeFirst()}
 **/
Cursor.prototype.isBeforeFirst = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBeforeFirst',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getColumnCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getColumnCount()}
 **/
Cursor.prototype.getColumnCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getString(int)}
 **/
Cursor.prototype.getString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNotificationUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getNotificationUri()}
 **/
Cursor.prototype.getNotificationUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNotificationUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getBlob
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getBlob(int)}
 **/
Cursor.prototype.getBlob = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBlob',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getLong(int)}
 **/
Cursor.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getInt(int)}
 **/
Cursor.prototype.getInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isAfterLast
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#isAfterLast()}
 **/
Cursor.prototype.isAfterLast = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAfterLast',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getPosition()}
 **/
Cursor.prototype.getPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isClosed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#isClosed()}
 **/
Cursor.prototype.isClosed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isClosed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getType(int)}
 **/
Cursor.prototype.getType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getColumnIndexOrThrow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getColumnIndexOrThrow(java.lang.String)}
 **/
Cursor.prototype.getColumnIndexOrThrow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnIndexOrThrow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function copyStringToBuffer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#copyStringToBuffer(int, android.database.CharArrayBuffer)}
 **/
Cursor.prototype.copyStringToBuffer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'copyStringToBuffer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isNull
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#isNull(int)}
 **/
Cursor.prototype.isNull = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNull',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function moveToPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#moveToPosition(int)}
 **/
Cursor.prototype.moveToPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'moveToPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getColumnIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#getColumnIndex(java.lang.String)}
 **/
Cursor.prototype.getColumnIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function requery
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#requery()}
 **/
Cursor.prototype.requery = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requery',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function respond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#respond(android.os.Bundle)}
 **/
Cursor.prototype.respond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'respond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function registerContentObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#registerContentObserver(android.database.ContentObserver)}
 **/
Cursor.prototype.registerContentObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerContentObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function moveToFirst
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/database/Cursor.html#moveToFirst()}
 **/
Cursor.prototype.moveToFirst = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'moveToFirst',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.database.Cursor') {
			return new Cursor(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Cursor.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Cursor.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Cursor;
