/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.Color
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics');

/**
 * @class android.graphics.Color
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html}
 **/
var Color = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.Color')) {
		result = arguments[0];
	}
	else {
		result = Color.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Color.prototype = Object.create(SuperClass.prototype);
Color.prototype.constructor = Color;

Object.defineProperty(Color.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Color(this.$native.super);
	},
	enumerable: true
});

Color.className = 'android.graphics.Color';
Color.prototype.className = 'android.graphics.Color';

// class property
Object.defineProperty(Color, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.Color');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Color.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.graphics.Color');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Color.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Color.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Color(Hyperloop.cast('android.graphics.Color', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#RED}
 */
Color.RED = -65536;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#DKGRAY}
 */
Color.DKGRAY = -12303292;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#GRAY}
 */
Color.GRAY = -7829368;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#WHITE}
 */
Color.WHITE = -1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#BLUE}
 */
Color.BLUE = -16776961;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#BLACK}
 */
Color.BLACK = -16777216;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#LTGRAY}
 */
Color.LTGRAY = -3355444;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#MAGENTA}
 */
Color.MAGENTA = -65281;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#YELLOW}
 */
Color.YELLOW = -256;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#CYAN}
 */
Color.CYAN = -16711681;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#GREEN}
 */
Color.GREEN = -16711936;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#TRANSPARENT}
 */
Color.TRANSPARENT = 0;

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function luminance
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#luminance(long)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#luminance(int)}
 **/
Color.luminance = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'luminance',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toArgb
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#toArgb(long)}
 **/
Color.toArgb = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'toArgb',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function convert
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#convert(int, android.graphics.ColorSpace)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#convert(long, android.graphics.ColorSpace)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#convert(float, float, float, float, android.graphics.ColorSpace, android.graphics.ColorSpace)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#convert(long, android.graphics.ColorSpace$Connector)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#convert(float, float, float, float, android.graphics.ColorSpace$Connector)}
 **/
Color.convert = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'convert',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rgb
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#rgb(int, int, int)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#rgb(float, float, float)}
 **/
Color.rgb = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'rgb',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function RGBToHSV
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#RGBToHSV(int, int, int, float[])}
 **/
Color.RGBToHSV = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'RGBToHSV',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parseColor
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#parseColor(java.lang.String)}
 **/
Color.parseColor = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parseColor',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function red
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#red(long)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#red(int)}
 **/
Color.red = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'red',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function colorSpace
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#colorSpace(long)}
 **/
Color.colorSpace = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'colorSpace',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isWideGamut
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#isWideGamut(long)}
 **/
Color.isWideGamut = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isWideGamut',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function alpha
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#alpha(long)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#alpha(int)}
 **/
Color.alpha = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'alpha',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function argb
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#argb(int, int, int, int)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#argb(float, float, float, float)}
 **/
Color.argb = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'argb',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function green
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#green(long)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#green(int)}
 **/
Color.green = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'green',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#valueOf(int)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#valueOf(long)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#valueOf(float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#valueOf(float, float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#valueOf(float, float, float, float, android.graphics.ColorSpace)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#valueOf(float[], android.graphics.ColorSpace)}
 **/
Color.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function HSVToColor
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#HSVToColor(float[])}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#HSVToColor(int, float[])}
 **/
Color.HSVToColor = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'HSVToColor',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSrgb
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#isSrgb(long)}
 **/
Color.isSrgb = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isSrgb',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function colorToHSV
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#colorToHSV(int, float[])}
 **/
Color.colorToHSV = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'colorToHSV',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pack
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#pack(int)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#pack(float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#pack(float, float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#pack(float, float, float, float, android.graphics.ColorSpace)}
 **/
Color.pack = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'pack',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function blue
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#blue(long)}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#blue(int)}
 **/
Color.blue = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'blue',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isInColorSpace
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#isInColorSpace(long, android.graphics.ColorSpace)}
 **/
Color.isInColorSpace = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isInColorSpace',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function luminance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#luminance()}
 **/
Color.prototype.luminance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'luminance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toArgb
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#toArgb()}
 **/
Color.prototype.toArgb = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toArgb',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function convert
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#convert(android.graphics.ColorSpace)}
 **/
Color.prototype.convert = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'convert',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function red
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#red()}
 **/
Color.prototype.red = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'red',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isWideGamut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#isWideGamut()}
 **/
Color.prototype.isWideGamut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWideGamut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#hashCode()}
 **/
Color.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function alpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#alpha()}
 **/
Color.prototype.alpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'alpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getComponents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#getComponents()}
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#getComponents(float[])}
 **/
Color.prototype.getComponents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComponents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getModel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#getModel()}
 **/
Color.prototype.getModel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getModel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function green
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#green()}
 **/
Color.prototype.green = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'green',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSrgb
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#isSrgb()}
 **/
Color.prototype.isSrgb = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSrgb',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getColorSpace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#getColorSpace()}
 **/
Color.prototype.getColorSpace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColorSpace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#pack()}
 **/
Color.prototype.pack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getComponentCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#getComponentCount()}
 **/
Color.prototype.getComponentCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComponentCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function blue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#blue()}
 **/
Color.prototype.blue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'blue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#equals(java.lang.Object)}
 **/
Color.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#toString()}
 **/
Color.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getComponent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/Color.html#getComponent(int)}
 **/
Color.prototype.getComponent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComponent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.Color') {
			return new Color(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Color;
