/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.ColorSpace$RenderIntent
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.graphics.ColorSpace');

/**
 * @class android.graphics.ColorSpace$RenderIntent
 * @extends java.lang.Enum 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html}
 **/
var RenderIntent = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.ColorSpace$RenderIntent')) {
		result = arguments[0];
	}
	else {
		result = RenderIntent.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Enum');
RenderIntent.prototype = Object.create(SuperClass.prototype);
RenderIntent.prototype.constructor = RenderIntent;

Object.defineProperty(RenderIntent.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new RenderIntent(this.$native.super);
	},
	enumerable: true
});

RenderIntent.className = 'android.graphics.ColorSpace$RenderIntent';
RenderIntent.prototype.className = 'android.graphics.ColorSpace$RenderIntent';

// class property
Object.defineProperty(RenderIntent, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.ColorSpace$RenderIntent');
	},
	enumerable: true,
	configurable: false
});


// Cast
RenderIntent.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new RenderIntent(Hyperloop.cast('android.graphics.ColorSpace$RenderIntent', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html#ABSOLUTE
Object.defineProperty(RenderIntent, 'ABSOLUTE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ABSOLUTE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$RenderIntent') {
				return new RenderIntent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html#RELATIVE
Object.defineProperty(RenderIntent, 'RELATIVE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RELATIVE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$RenderIntent') {
				return new RenderIntent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html#PERCEPTUAL
Object.defineProperty(RenderIntent, 'PERCEPTUAL', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('PERCEPTUAL');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$RenderIntent') {
				return new RenderIntent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html#SATURATION
Object.defineProperty(RenderIntent, 'SATURATION', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SATURATION');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$RenderIntent') {
				return new RenderIntent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html#valueOf(java.lang.String)}
 **/
RenderIntent.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$RenderIntent') {
			return new RenderIntent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.RenderIntent.html#values()}
 **/
RenderIntent.values = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'values',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$RenderIntent') {
			return new RenderIntent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = RenderIntent;
