/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.ColorSpace
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics');

/**
 * @class android.graphics.ColorSpace
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html}
 **/
var ColorSpace = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.ColorSpace')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.graphics.ColorSpace. Create a subclass using android.graphics.ColorSpace.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ColorSpace.prototype = Object.create(SuperClass.prototype);
ColorSpace.prototype.constructor = ColorSpace;

Object.defineProperty(ColorSpace.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ColorSpace(this.$native.super);
	},
	enumerable: true
});

ColorSpace.className = 'android.graphics.ColorSpace';
ColorSpace.prototype.className = 'android.graphics.ColorSpace';

// class property
Object.defineProperty(ColorSpace, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.ColorSpace');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ColorSpace.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.graphics.ColorSpace');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ColorSpace.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ColorSpace.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ColorSpace(Hyperloop.cast('android.graphics.ColorSpace', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#MAX_ID}
 */
ColorSpace.MAX_ID = 63;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#MIN_ID}
 */
ColorSpace.MIN_ID = -1;

// Inner classes
Object.defineProperty(ColorSpace, 'RenderIntent', {
	get: function() {
		return require('./android.graphics.ColorSpace$RenderIntent');
	},
	enumerable: true
});
Object.defineProperty(ColorSpace, 'Named', {
	get: function() {
		return require('./android.graphics.ColorSpace$Named');
	},
	enumerable: true
});
Object.defineProperty(ColorSpace, 'Connector', {
	get: function() {
		return require('./android.graphics.ColorSpace$Connector');
	},
	enumerable: true
});
Object.defineProperty(ColorSpace, 'Adaptation', {
	get: function() {
		return require('./android.graphics.ColorSpace$Adaptation');
	},
	enumerable: true
});
Object.defineProperty(ColorSpace, 'Rgb$TransferParameters', {
	get: function() {
		return require('./android.graphics.ColorSpace$Rgb$TransferParameters');
	},
	enumerable: true
});
Object.defineProperty(ColorSpace, 'Rgb', {
	get: function() {
		return require('./android.graphics.ColorSpace$Rgb');
	},
	enumerable: true
});
Object.defineProperty(ColorSpace, 'Model', {
	get: function() {
		return require('./android.graphics.ColorSpace$Model');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_E
Object.defineProperty(ColorSpace, 'ILLUMINANT_E', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_E');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_C
Object.defineProperty(ColorSpace, 'ILLUMINANT_C', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_C');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_D60
Object.defineProperty(ColorSpace, 'ILLUMINANT_D60', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_D60');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_B
Object.defineProperty(ColorSpace, 'ILLUMINANT_B', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_B');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_D50
Object.defineProperty(ColorSpace, 'ILLUMINANT_D50', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_D50');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_A
Object.defineProperty(ColorSpace, 'ILLUMINANT_A', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_A');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_D55
Object.defineProperty(ColorSpace, 'ILLUMINANT_D55', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_D55');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_D75
Object.defineProperty(ColorSpace, 'ILLUMINANT_D75', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_D75');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.html#ILLUMINANT_D65
Object.defineProperty(ColorSpace, 'ILLUMINANT_D65', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ILLUMINANT_D65');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace') {
				return new ColorSpace(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function adapt
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#adapt(android.graphics.ColorSpace, float[])}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#adapt(android.graphics.ColorSpace, float[], android.graphics.ColorSpace$Adaptation)}
 **/
ColorSpace.adapt = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'adapt',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function match
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#match(float[], android.graphics.ColorSpace$Rgb$TransferParameters)}
 **/
ColorSpace.match = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'match',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#get(android.graphics.ColorSpace$Named)}
 **/
ColorSpace.get = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'get',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function connect
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#connect(android.graphics.ColorSpace, android.graphics.ColorSpace)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#connect(android.graphics.ColorSpace, android.graphics.ColorSpace, android.graphics.ColorSpace$RenderIntent)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#connect(android.graphics.ColorSpace)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#connect(android.graphics.ColorSpace, android.graphics.ColorSpace$RenderIntent)}
 **/
ColorSpace.connect = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'connect',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getModel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#getModel()}
 **/
ColorSpace.prototype.getModel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getModel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#getName()}
 **/
ColorSpace.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMaxValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#getMaxValue(int)}
 **/
ColorSpace.prototype.getMaxValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaxValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toXyz
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#toXyz(float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#toXyz(float[])}
 **/
ColorSpace.prototype.toXyz = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toXyz',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#getId()}
 **/
ColorSpace.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSrgb
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#isSrgb()}
 **/
ColorSpace.prototype.isSrgb = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSrgb',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getComponentCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#getComponentCount()}
 **/
ColorSpace.prototype.getComponentCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComponentCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isWideGamut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#isWideGamut()}
 **/
ColorSpace.prototype.isWideGamut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWideGamut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#getMinValue(int)}
 **/
ColorSpace.prototype.getMinValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#hashCode()}
 **/
ColorSpace.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#equals(java.lang.Object)}
 **/
ColorSpace.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#toString()}
 **/
ColorSpace.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fromXyz
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#fromXyz(float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.html#fromXyz(float[])}
 **/
ColorSpace.prototype.fromXyz = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fromXyz',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace') {
			return new ColorSpace(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ColorSpace;
