/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.Gravity
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.Gravity
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html}
 **/
var Gravity = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.Gravity')) {
		result = arguments[0];
	}
	else {
		result = Gravity.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Gravity.prototype = Object.create(SuperClass.prototype);
Gravity.prototype.constructor = Gravity;

Object.defineProperty(Gravity.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Gravity(this.$native.super);
	},
	enumerable: true
});

Gravity.className = 'android.view.Gravity';
Gravity.prototype.className = 'android.view.Gravity';

// class property
Object.defineProperty(Gravity, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.Gravity');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Gravity.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.Gravity');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Gravity.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Gravity.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Gravity(Hyperloop.cast('android.view.Gravity', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#AXIS_X_SHIFT}
 */
Gravity.AXIS_X_SHIFT = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#FILL_VERTICAL}
 */
Gravity.FILL_VERTICAL = 112;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#AXIS_CLIP}
 */
Gravity.AXIS_CLIP = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#AXIS_PULL_BEFORE}
 */
Gravity.AXIS_PULL_BEFORE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#DISPLAY_CLIP_VERTICAL}
 */
Gravity.DISPLAY_CLIP_VERTICAL = 268435456;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#BOTTOM}
 */
Gravity.BOTTOM = 80;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#AXIS_SPECIFIED}
 */
Gravity.AXIS_SPECIFIED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#CENTER}
 */
Gravity.CENTER = 17;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#CLIP_HORIZONTAL}
 */
Gravity.CLIP_HORIZONTAL = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#RELATIVE_LAYOUT_DIRECTION}
 */
Gravity.RELATIVE_LAYOUT_DIRECTION = 8388608;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#CENTER_HORIZONTAL}
 */
Gravity.CENTER_HORIZONTAL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#AXIS_PULL_AFTER}
 */
Gravity.AXIS_PULL_AFTER = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#RIGHT}
 */
Gravity.RIGHT = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#AXIS_Y_SHIFT}
 */
Gravity.AXIS_Y_SHIFT = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#NO_GRAVITY}
 */
Gravity.NO_GRAVITY = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#FILL}
 */
Gravity.FILL = 119;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#HORIZONTAL_GRAVITY_MASK}
 */
Gravity.HORIZONTAL_GRAVITY_MASK = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#VERTICAL_GRAVITY_MASK}
 */
Gravity.VERTICAL_GRAVITY_MASK = 112;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#LEFT}
 */
Gravity.LEFT = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#RELATIVE_HORIZONTAL_GRAVITY_MASK}
 */
Gravity.RELATIVE_HORIZONTAL_GRAVITY_MASK = 8388615;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#TOP}
 */
Gravity.TOP = 48;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#END}
 */
Gravity.END = 8388613;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#START}
 */
Gravity.START = 8388611;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#CENTER_VERTICAL}
 */
Gravity.CENTER_VERTICAL = 16;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#CLIP_VERTICAL}
 */
Gravity.CLIP_VERTICAL = 128;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#DISPLAY_CLIP_HORIZONTAL}
 */
Gravity.DISPLAY_CLIP_HORIZONTAL = 16777216;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#FILL_HORIZONTAL}
 */
Gravity.FILL_HORIZONTAL = 7;

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function isVertical
 * @static
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#isVertical(int)}
 **/
Gravity.isVertical = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isVertical',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Gravity') {
			return new Gravity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAbsoluteGravity
 * @static
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#getAbsoluteGravity(int, int)}
 **/
Gravity.getAbsoluteGravity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAbsoluteGravity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Gravity') {
			return new Gravity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function apply
 * @static
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#apply(int, int, int, android.graphics.Rect, android.graphics.Rect)}
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#apply(int, int, int, android.graphics.Rect, android.graphics.Rect, int)}
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#apply(int, int, int, android.graphics.Rect, int, int, android.graphics.Rect)}
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#apply(int, int, int, android.graphics.Rect, int, int, android.graphics.Rect, int)}
 **/
Gravity.apply = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'apply',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Gravity') {
			return new Gravity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyDisplay
 * @static
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#applyDisplay(int, android.graphics.Rect, android.graphics.Rect)}
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#applyDisplay(int, android.graphics.Rect, android.graphics.Rect, int)}
 **/
Gravity.applyDisplay = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'applyDisplay',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Gravity') {
			return new Gravity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isHorizontal
 * @static
 * @see {@link http://developer.android.com/reference/android/view/Gravity.html#isHorizontal(int)}
 **/
Gravity.isHorizontal = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isHorizontal',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Gravity') {
			return new Gravity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = Gravity;
