/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module MenuItem
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * constructor
 * http://developer.android.com/reference/android/view/MenuItem.html
 **/
var MenuItem = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.view.MenuItem') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.view.MenuItem');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
MenuItem.prototype = Object.create(SuperClass.prototype);
MenuItem.prototype.constructor = MenuItem;

Object.defineProperty(MenuItem.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MenuItem(this.$native.super);
	},
	enumerable: true
});

MenuItem.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

MenuItem.className = "android.view.MenuItem";
MenuItem.prototype.className = "android.view.MenuItem";

// class property
Object.defineProperty(MenuItem, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.MenuItem');
	},
	enumerable: true,
	configurable: false
});

// Cast
MenuItem.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MenuItem(Hyperloop.cast('android.view.MenuItem', object.$native));
};

// Constants
// http://developer.android.com/reference/android/view/MenuItem.html#SHOW_AS_ACTION_IF_ROOM
MenuItem.SHOW_AS_ACTION_IF_ROOM = 1;
// http://developer.android.com/reference/android/view/MenuItem.html#SHOW_AS_ACTION_COLLAPSE_ACTION_VIEW
MenuItem.SHOW_AS_ACTION_COLLAPSE_ACTION_VIEW = 8;
// http://developer.android.com/reference/android/view/MenuItem.html#SHOW_AS_ACTION_NEVER
MenuItem.SHOW_AS_ACTION_NEVER = 0;
// http://developer.android.com/reference/android/view/MenuItem.html#SHOW_AS_ACTION_ALWAYS
MenuItem.SHOW_AS_ACTION_ALWAYS = 2;
// http://developer.android.com/reference/android/view/MenuItem.html#SHOW_AS_ACTION_WITH_TEXT
MenuItem.SHOW_AS_ACTION_WITH_TEXT = 4;

// Static methods

// Instance methods
/**
 * @function getIconTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getIconTintMode()}
 **/
MenuItem.prototype.getIconTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIconTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setIconTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setIconTintList(android.content.res.ColorStateList)}
 **/
MenuItem.prototype.setIconTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIconTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setActionProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setActionProvider(android.view.ActionProvider)}
 **/
MenuItem.prototype.setActionProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setActionProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIconTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getIconTintList()}
 **/
MenuItem.prototype.getIconTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIconTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hasSubMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#hasSubMenu()}
 **/
MenuItem.prototype.hasSubMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasSubMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setOnActionExpandListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setOnActionExpandListener(android.view.MenuItem$OnActionExpandListener)}
 **/
MenuItem.prototype.setOnActionExpandListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnActionExpandListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function expandActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#expandActionView()}
 **/
MenuItem.prototype.expandActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'expandActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getContentDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getContentDescription()}
 **/
MenuItem.prototype.getContentDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContentDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTitleCondensed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getTitleCondensed()}
 **/
MenuItem.prototype.getTitleCondensed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTitleCondensed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function collapseActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#collapseActionView()}
 **/
MenuItem.prototype.collapseActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'collapseActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getGroupId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getGroupId()}
 **/
MenuItem.prototype.getGroupId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGroupId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setIconTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setIconTintMode(android.graphics.PorterDuff$Mode)}
 **/
MenuItem.prototype.setIconTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIconTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getItemId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getItemId()}
 **/
MenuItem.prototype.getItemId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItemId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getTitle()}
 **/
MenuItem.prototype.getTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getActionView()}
 **/
MenuItem.prototype.getActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAlphabeticModifiers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getAlphabeticModifiers()}
 **/
MenuItem.prototype.getAlphabeticModifiers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAlphabeticModifiers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTooltipText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getTooltipText()}
 **/
MenuItem.prototype.getTooltipText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTooltipText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setChecked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setChecked(boolean)}
 **/
MenuItem.prototype.setChecked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setChecked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAlphabeticShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getAlphabeticShortcut()}
 **/
MenuItem.prototype.getAlphabeticShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAlphabeticShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setOnMenuItemClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setOnMenuItemClickListener(android.view.MenuItem$OnMenuItemClickListener)}
 **/
MenuItem.prototype.setOnMenuItemClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnMenuItemClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getIntent()}
 **/
MenuItem.prototype.getIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setContentDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setContentDescription(java.lang.CharSequence)}
 **/
MenuItem.prototype.setContentDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isCheckable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#isCheckable()}
 **/
MenuItem.prototype.isCheckable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isCheckable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setShortcut(char, char)}
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setShortcut(char, char, int, int)}
 **/
MenuItem.prototype.setShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setVisible(boolean)}
 **/
MenuItem.prototype.setVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isActionViewExpanded
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#isActionViewExpanded()}
 **/
MenuItem.prototype.isActionViewExpanded = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isActionViewExpanded',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setShowAsAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setShowAsAction(int)}
 **/
MenuItem.prototype.setShowAsAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setShowAsAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setIntent(android.content.Intent)}
 **/
MenuItem.prototype.setIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSubMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getSubMenu()}
 **/
MenuItem.prototype.getSubMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSubMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setCheckable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setCheckable(boolean)}
 **/
MenuItem.prototype.setCheckable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCheckable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setTitle(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setTitle(int)}
 **/
MenuItem.prototype.setTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setAlphabeticShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setAlphabeticShortcut(char)}
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setAlphabeticShortcut(char, int)}
 **/
MenuItem.prototype.setAlphabeticShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAlphabeticShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setNumericShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setNumericShortcut(char)}
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setNumericShortcut(char, int)}
 **/
MenuItem.prototype.setNumericShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setNumericShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getActionProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getActionProvider()}
 **/
MenuItem.prototype.getActionProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActionProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#isVisible()}
 **/
MenuItem.prototype.isVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isChecked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#isChecked()}
 **/
MenuItem.prototype.isChecked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isChecked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setTitleCondensed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setTitleCondensed(java.lang.CharSequence)}
 **/
MenuItem.prototype.setTitleCondensed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTitleCondensed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getIcon()}
 **/
MenuItem.prototype.getIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setIcon(android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setIcon(int)}
 **/
MenuItem.prototype.setIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setEnabled(boolean)}
 **/
MenuItem.prototype.setEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setShowAsActionFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setShowAsActionFlags(int)}
 **/
MenuItem.prototype.setShowAsActionFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setShowAsActionFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getOrder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getOrder()}
 **/
MenuItem.prototype.getOrder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOrder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#isEnabled()}
 **/
MenuItem.prototype.isEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNumericShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getNumericShortcut()}
 **/
MenuItem.prototype.getNumericShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNumericShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNumericModifiers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getNumericModifiers()}
 **/
MenuItem.prototype.getNumericModifiers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNumericModifiers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setActionView(android.view.View)}
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setActionView(int)}
 **/
MenuItem.prototype.setActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getMenuInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#getMenuInfo()}
 **/
MenuItem.prototype.getMenuInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMenuInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setTooltipText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/MenuItem.html#setTooltipText(java.lang.CharSequence)}
 **/
MenuItem.prototype.setTooltipText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTooltipText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.MenuItem') {
			return new MenuItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

MenuItem.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

MenuItem.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = MenuItem;
