/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.autofill.AutofillValue
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.autofill');

/**
 * @class android.view.autofill.AutofillValue
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html}
 **/
var AutofillValue = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.autofill.AutofillValue')) {
		result = arguments[0];
	}
	else {
		result = AutofillValue.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AutofillValue.prototype = Object.create(SuperClass.prototype);
AutofillValue.prototype.constructor = AutofillValue;

Object.defineProperty(AutofillValue.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AutofillValue(this.$native.super);
	},
	enumerable: true
});

AutofillValue.className = 'android.view.autofill.AutofillValue';
AutofillValue.prototype.className = 'android.view.autofill.AutofillValue';

// class property
Object.defineProperty(AutofillValue, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.autofill.AutofillValue');
	},
	enumerable: true,
	configurable: false
});


// Cast
AutofillValue.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AutofillValue(Hyperloop.cast('android.view.autofill.AutofillValue', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/view/autofill/AutofillValue.html#CREATOR
Object.defineProperty(AutofillValue, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.autofill.AutofillValue') {
				return new AutofillValue(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function forText
 * @static
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#forText(java.lang.CharSequence)}
 **/
AutofillValue.forText = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forText',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forToggle
 * @static
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#forToggle(boolean)}
 **/
AutofillValue.forToggle = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forToggle',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forList
 * @static
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#forList(int)}
 **/
AutofillValue.forList = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forList',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forDate
 * @static
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#forDate(long)}
 **/
AutofillValue.forDate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forDate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getTextValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#getTextValue()}
 **/
AutofillValue.prototype.getTextValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getListValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#getListValue()}
 **/
AutofillValue.prototype.getListValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getListValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#isList()}
 **/
AutofillValue.prototype.isList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#describeContents()}
 **/
AutofillValue.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getToggleValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#getToggleValue()}
 **/
AutofillValue.prototype.getToggleValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getToggleValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isToggle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#isToggle()}
 **/
AutofillValue.prototype.isToggle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isToggle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#hashCode()}
 **/
AutofillValue.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#equals(java.lang.Object)}
 **/
AutofillValue.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#isDate()}
 **/
AutofillValue.prototype.isDate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#toString()}
 **/
AutofillValue.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDateValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#getDateValue()}
 **/
AutofillValue.prototype.getDateValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDateValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#writeToParcel(android.os.Parcel, int)}
 **/
AutofillValue.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/autofill/AutofillValue.html#isText()}
 **/
AutofillValue.prototype.isText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.autofill.AutofillValue') {
			return new AutofillValue(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AutofillValue;
