/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.inputmethod.InputContentInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.inputmethod');

/**
 * @class android.view.inputmethod.InputContentInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html}
 **/
var InputContentInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.inputmethod.InputContentInfo')) {
		result = arguments[0];
	}
	else {
		result = InputContentInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
InputContentInfo.prototype = Object.create(SuperClass.prototype);
InputContentInfo.prototype.constructor = InputContentInfo;

Object.defineProperty(InputContentInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new InputContentInfo(this.$native.super);
	},
	enumerable: true
});

InputContentInfo.className = 'android.view.inputmethod.InputContentInfo';
InputContentInfo.prototype.className = 'android.view.inputmethod.InputContentInfo';

// class property
Object.defineProperty(InputContentInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.inputmethod.InputContentInfo');
	},
	enumerable: true,
	configurable: false
});


// Cast
InputContentInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new InputContentInfo(Hyperloop.cast('android.view.inputmethod.InputContentInfo', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#CREATOR
Object.defineProperty(InputContentInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
				return new InputContentInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function requestPermission
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#requestPermission()}
 **/
InputContentInfo.prototype.requestPermission = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestPermission',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function releasePermission
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#releasePermission()}
 **/
InputContentInfo.prototype.releasePermission = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'releasePermission',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLinkUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#getLinkUri()}
 **/
InputContentInfo.prototype.getLinkUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLinkUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getContentUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#getContentUri()}
 **/
InputContentInfo.prototype.getContentUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContentUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#getDescription()}
 **/
InputContentInfo.prototype.getDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
InputContentInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputContentInfo.html#describeContents()}
 **/
InputContentInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputContentInfo') {
			return new InputContentInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = InputContentInfo;
