/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.daimajia.androidanimations.library.BaseViewAnimator
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.daimajia.androidanimations.library');

/**
 * @class com.daimajia.androidanimations.library.BaseViewAnimator
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html}
 **/
var BaseViewAnimator = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.daimajia.androidanimations.library.BaseViewAnimator')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.daimajia.androidanimations.library.BaseViewAnimator. Create a subclass using com.daimajia.androidanimations.library.BaseViewAnimator.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
BaseViewAnimator.prototype = Object.create(SuperClass.prototype);
BaseViewAnimator.prototype.constructor = BaseViewAnimator;

Object.defineProperty(BaseViewAnimator.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new BaseViewAnimator(this.$native.super);
	},
	enumerable: true
});

BaseViewAnimator.className = 'com.daimajia.androidanimations.library.BaseViewAnimator';
BaseViewAnimator.prototype.className = 'com.daimajia.androidanimations.library.BaseViewAnimator';

// class property
Object.defineProperty(BaseViewAnimator, 'class', {
	get: function() {
		return Hyperloop.getClass('com.daimajia.androidanimations.library.BaseViewAnimator');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
BaseViewAnimator.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.daimajia.androidanimations.library.BaseViewAnimator');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(BaseViewAnimator.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
BaseViewAnimator.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new BaseViewAnimator(Hyperloop.cast('com.daimajia.androidanimations.library.BaseViewAnimator', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#DURATION}
 */
BaseViewAnimator.DURATION = 1000;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#setDuration(long)}
 **/
BaseViewAnimator.prototype.setDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function cancel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#cancel()}
 **/
BaseViewAnimator.prototype.cancel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cancel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function prepare
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#prepare(android.view.View)}
 **/
BaseViewAnimator.prototype.prepare = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prepare',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeAnimatorListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#removeAnimatorListener(com.nineoldandroids.animation.Animator$AnimatorListener)}
 **/
BaseViewAnimator.prototype.removeAnimatorListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeAnimatorListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInterpolator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#setInterpolator(android.view.animation.Interpolator)}
 **/
BaseViewAnimator.prototype.setInterpolator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInterpolator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function start
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#start()}
 **/
BaseViewAnimator.prototype.start = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'start',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#isStarted()}
 **/
BaseViewAnimator.prototype.isStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnimatorAgent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#getAnimatorAgent()}
 **/
BaseViewAnimator.prototype.getAnimatorAgent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnimatorAgent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function animate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#animate(android.view.View)}
 **/
BaseViewAnimator.prototype.animate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'animate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addAnimatorListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#addAnimatorListener(com.nineoldandroids.animation.Animator$AnimatorListener)}
 **/
BaseViewAnimator.prototype.addAnimatorListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addAnimatorListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartDelay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#getStartDelay()}
 **/
BaseViewAnimator.prototype.getStartDelay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartDelay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#getDuration()}
 **/
BaseViewAnimator.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isRunning
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#isRunning()}
 **/
BaseViewAnimator.prototype.isRunning = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isRunning',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeAllListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#removeAllListener()}
 **/
BaseViewAnimator.prototype.removeAllListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeAllListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#reset(android.view.View)}
 **/
BaseViewAnimator.prototype.reset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setStartDelay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/daimajia/androidanimations/library/BaseViewAnimator.html#setStartDelay(long)}
 **/
BaseViewAnimator.prototype.setStartDelay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setStartDelay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.daimajia.androidanimations.library.BaseViewAnimator') {
			return new BaseViewAnimator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = BaseViewAnimator;
