/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module BasicFileAttributes
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.nio.file.attribute');

/**
 * constructor
 * http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html
 **/
var BasicFileAttributes = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.nio.file.attribute.BasicFileAttributes') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.nio.file.attribute.BasicFileAttributes');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
BasicFileAttributes.prototype = Object.create(SuperClass.prototype);
BasicFileAttributes.prototype.constructor = BasicFileAttributes;

Object.defineProperty(BasicFileAttributes.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new BasicFileAttributes(this.$native.super);
	},
	enumerable: true
});

BasicFileAttributes.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

BasicFileAttributes.className = "java.nio.file.attribute.BasicFileAttributes";
BasicFileAttributes.prototype.className = "java.nio.file.attribute.BasicFileAttributes";

// class property
Object.defineProperty(BasicFileAttributes, 'class', {
	get: function() {
		return Hyperloop.getClass('java.nio.file.attribute.BasicFileAttributes');
	},
	enumerable: true,
	configurable: false
});

// Cast
BasicFileAttributes.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new BasicFileAttributes(Hyperloop.cast('java.nio.file.attribute.BasicFileAttributes', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function lastModifiedTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#lastModifiedTime()}
 **/
BasicFileAttributes.prototype.lastModifiedTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lastModifiedTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function lastAccessTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#lastAccessTime()}
 **/
BasicFileAttributes.prototype.lastAccessTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lastAccessTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function creationTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#creationTime()}
 **/
BasicFileAttributes.prototype.creationTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'creationTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function size
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#size()}
 **/
BasicFileAttributes.prototype.size = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'size',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isSymbolicLink
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#isSymbolicLink()}
 **/
BasicFileAttributes.prototype.isSymbolicLink = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSymbolicLink',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isRegularFile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#isRegularFile()}
 **/
BasicFileAttributes.prototype.isRegularFile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isRegularFile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function fileKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#fileKey()}
 **/
BasicFileAttributes.prototype.fileKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fileKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isOther
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#isOther()}
 **/
BasicFileAttributes.prototype.isOther = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOther',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isDirectory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/nio/file/attribute/BasicFileAttributes.html#isDirectory()}
 **/
BasicFileAttributes.prototype.isDirectory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDirectory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.nio.file.attribute.BasicFileAttributes') {
			return new BasicFileAttributes(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

BasicFileAttributes.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

BasicFileAttributes.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = BasicFileAttributes;
