/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.HashMap
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util');

/**
 * @class java.util.HashMap
 * @extends java.util.AbstractMap 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html}
 **/
var HashMap = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.HashMap')) {
		result = arguments[0];
	}
	else {
		result = HashMap.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.util.AbstractMap');
HashMap.prototype = Object.create(SuperClass.prototype);
HashMap.prototype.constructor = HashMap;

Object.defineProperty(HashMap.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new HashMap(this.$native.super);
	},
	enumerable: true
});

HashMap.className = 'java.util.HashMap';
HashMap.prototype.className = 'java.util.HashMap';

// class property
Object.defineProperty(HashMap, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.HashMap');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
HashMap.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.util.HashMap');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(HashMap.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
HashMap.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new HashMap(Hyperloop.cast('java.util.HashMap', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(HashMap, 'EntrySpliterator', {
	get: function() {
		return require('./java.util.HashMap$EntrySpliterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'HashMapSpliterator', {
	get: function() {
		return require('./java.util.HashMap$HashMapSpliterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'KeySpliterator', {
	get: function() {
		return require('./java.util.HashMap$KeySpliterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'ValueSpliterator', {
	get: function() {
		return require('./java.util.HashMap$ValueSpliterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'Values', {
	get: function() {
		return require('./java.util.HashMap$Values');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'ValueIterator', {
	get: function() {
		return require('./java.util.HashMap$ValueIterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'TreeNode', {
	get: function() {
		return require('./java.util.HashMap$TreeNode');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'Node', {
	get: function() {
		return require('./java.util.HashMap$Node');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'KeySet', {
	get: function() {
		return require('./java.util.HashMap$KeySet');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'KeyIterator', {
	get: function() {
		return require('./java.util.HashMap$KeyIterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'HashIterator', {
	get: function() {
		return require('./java.util.HashMap$HashIterator');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'EntrySet', {
	get: function() {
		return require('./java.util.HashMap$EntrySet');
	},
	enumerable: true
});
Object.defineProperty(HashMap, 'EntryIterator', {
	get: function() {
		return require('./java.util.HashMap$EntryIterator');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getOrDefault
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#getOrDefault(java.lang.Object, java.lang.Object)}
 **/
HashMap.prototype.getOrDefault = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOrDefault',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function entrySet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#entrySet()}
 **/
HashMap.prototype.entrySet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'entrySet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function containsKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#containsKey(java.lang.Object)}
 **/
HashMap.prototype.containsKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'containsKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forEach
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#forEach(java.util.function.BiConsumer)}
 **/
HashMap.prototype.forEach = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEach',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#values()}
 **/
HashMap.prototype.values = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'values',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeIfAbsent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#computeIfAbsent(java.lang.Object, java.util.function.Function)}
 **/
HashMap.prototype.computeIfAbsent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeIfAbsent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEmpty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#isEmpty()}
 **/
HashMap.prototype.isEmpty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEmpty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#clear()}
 **/
HashMap.prototype.clear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function replace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#replace(java.lang.Object, java.lang.Object, java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#replace(java.lang.Object, java.lang.Object)}
 **/
HashMap.prototype.replace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'replace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function replaceAll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#replaceAll(java.util.function.BiFunction)}
 **/
HashMap.prototype.replaceAll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'replaceAll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function put
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#put(java.lang.Object, java.lang.Object)}
 **/
HashMap.prototype.put = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'put',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#remove(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#remove(java.lang.Object, java.lang.Object)}
 **/
HashMap.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function containsValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#containsValue(java.lang.Object)}
 **/
HashMap.prototype.containsValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'containsValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#compute(java.lang.Object, java.util.function.BiFunction)}
 **/
HashMap.prototype.compute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeIfPresent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#computeIfPresent(java.lang.Object, java.util.function.BiFunction)}
 **/
HashMap.prototype.computeIfPresent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeIfPresent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function size
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#size()}
 **/
HashMap.prototype.size = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'size',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#get(java.lang.Object)}
 **/
HashMap.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putAll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#putAll(java.util.Map)}
 **/
HashMap.prototype.putAll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putAll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function merge
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#merge(java.lang.Object, java.lang.Object, java.util.function.BiFunction)}
 **/
HashMap.prototype.merge = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'merge',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#clone()}
 **/
HashMap.prototype.clone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function keySet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#keySet()}
 **/
HashMap.prototype.keySet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'keySet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putIfAbsent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.html#putIfAbsent(java.lang.Object, java.lang.Object)}
 **/
HashMap.prototype.putIfAbsent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putIfAbsent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap') {
			return new HashMap(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = HashMap;
