/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ListIterator
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util');

/**
 * constructor
 * http://developer.android.com/reference/java/util/ListIterator.html
 **/
var ListIterator = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.ListIterator') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.ListIterator');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ListIterator.prototype = Object.create(SuperClass.prototype);
ListIterator.prototype.constructor = ListIterator;

Object.defineProperty(ListIterator.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ListIterator(this.$native.super);
	},
	enumerable: true
});

ListIterator.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ListIterator.className = "java.util.ListIterator";
ListIterator.prototype.className = "java.util.ListIterator";

// class property
Object.defineProperty(ListIterator, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.ListIterator');
	},
	enumerable: true,
	configurable: false
});

// Cast
ListIterator.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ListIterator(Hyperloop.cast('java.util.ListIterator', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function next
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#next()}
 **/
ListIterator.prototype.next = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'next',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function add
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#add(java.lang.Object)}
 **/
ListIterator.prototype.add = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'add',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function set
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#set(java.lang.Object)}
 **/
ListIterator.prototype.set = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'set',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function previous
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#previous()}
 **/
ListIterator.prototype.previous = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'previous',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hasPrevious
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#hasPrevious()}
 **/
ListIterator.prototype.hasPrevious = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasPrevious',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hasNext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#hasNext()}
 **/
ListIterator.prototype.hasNext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasNext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#nextIndex()}
 **/
ListIterator.prototype.nextIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function previousIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#previousIndex()}
 **/
ListIterator.prototype.previousIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'previousIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/ListIterator.html#remove()}
 **/
ListIterator.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.ListIterator') {
			return new ListIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ListIterator.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ListIterator.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ListIterator;
