/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.UUID
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util');

/**
 * @class java.util.UUID
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/UUID.html}
 **/
var UUID = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.UUID')) {
		result = arguments[0];
	}
	else {
		result = UUID.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
UUID.prototype = Object.create(SuperClass.prototype);
UUID.prototype.constructor = UUID;

Object.defineProperty(UUID.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new UUID(this.$native.super);
	},
	enumerable: true
});

UUID.className = 'java.util.UUID';
UUID.prototype.className = 'java.util.UUID';

// class property
Object.defineProperty(UUID, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.UUID');
	},
	enumerable: true,
	configurable: false
});


// Cast
UUID.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new UUID(Hyperloop.cast('java.util.UUID', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(UUID, 'Holder', {
	get: function() {
		return require('./java.util.UUID$Holder');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function nameUUIDFromBytes
 * @static
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#nameUUIDFromBytes(byte[])}
 **/
UUID.nameUUIDFromBytes = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'nameUUIDFromBytes',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function randomUUID
 * @static
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#randomUUID()}
 **/
UUID.randomUUID = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'randomUUID',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fromString
 * @static
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#fromString(java.lang.String)}
 **/
UUID.fromString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fromString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#compareTo(java.util.UUID)}
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#compareTo(java.lang.Object)}
 **/
UUID.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLeastSignificantBits
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#getLeastSignificantBits()}
 **/
UUID.prototype.getLeastSignificantBits = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLeastSignificantBits',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function version
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#version()}
 **/
UUID.prototype.version = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'version',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function node
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#node()}
 **/
UUID.prototype.node = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'node',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMostSignificantBits
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#getMostSignificantBits()}
 **/
UUID.prototype.getMostSignificantBits = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMostSignificantBits',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#hashCode()}
 **/
UUID.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#equals(java.lang.Object)}
 **/
UUID.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function variant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#variant()}
 **/
UUID.prototype.variant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'variant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#toString()}
 **/
UUID.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clockSequence
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#clockSequence()}
 **/
UUID.prototype.clockSequence = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clockSequence',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function timestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/UUID.html#timestamp()}
 **/
UUID.prototype.timestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'timestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.UUID') {
			return new UUID(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = UUID;
