/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ExecutorService
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.concurrent');

/**
 * constructor
 * http://developer.android.com/reference/java/util/concurrent/ExecutorService.html
 **/
var ExecutorService = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.concurrent.ExecutorService') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.concurrent.ExecutorService');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ExecutorService.prototype = Object.create(SuperClass.prototype);
ExecutorService.prototype.constructor = ExecutorService;

Object.defineProperty(ExecutorService.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ExecutorService(this.$native.super);
	},
	enumerable: true
});

ExecutorService.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ExecutorService.className = "java.util.concurrent.ExecutorService";
ExecutorService.prototype.className = "java.util.concurrent.ExecutorService";

// class property
Object.defineProperty(ExecutorService, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.concurrent.ExecutorService');
	},
	enumerable: true,
	configurable: false
});

// Cast
ExecutorService.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ExecutorService(Hyperloop.cast('java.util.concurrent.ExecutorService', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function submit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#submit(java.util.concurrent.Callable)}
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#submit(java.lang.Runnable, java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#submit(java.lang.Runnable)}
 **/
ExecutorService.prototype.submit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'submit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isTerminated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#isTerminated()}
 **/
ExecutorService.prototype.isTerminated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isTerminated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function invokeAll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#invokeAll(java.util.Collection)}
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#invokeAll(java.util.Collection, long, java.util.concurrent.TimeUnit)}
 **/
ExecutorService.prototype.invokeAll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invokeAll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function awaitTermination
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#awaitTermination(long, java.util.concurrent.TimeUnit)}
 **/
ExecutorService.prototype.awaitTermination = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'awaitTermination',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function shutdownNow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#shutdownNow()}
 **/
ExecutorService.prototype.shutdownNow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shutdownNow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function invokeAny
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#invokeAny(java.util.Collection)}
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#invokeAny(java.util.Collection, long, java.util.concurrent.TimeUnit)}
 **/
ExecutorService.prototype.invokeAny = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invokeAny',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function execute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#execute(java.lang.Runnable)}
 **/
ExecutorService.prototype.execute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'execute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function shutdown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#shutdown()}
 **/
ExecutorService.prototype.shutdown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shutdown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isShutdown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/ExecutorService.html#isShutdown()}
 **/
ExecutorService.prototype.isShutdown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isShutdown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.ExecutorService') {
			return new ExecutorService(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ExecutorService.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ExecutorService.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ExecutorService;
