/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Stream
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.stream');

/**
 * constructor
 * http://developer.android.com/reference/java/util/stream/Stream.html
 **/
var Stream = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.stream.Stream') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.stream.Stream');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Stream.prototype = Object.create(SuperClass.prototype);
Stream.prototype.constructor = Stream;

Object.defineProperty(Stream.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Stream(this.$native.super);
	},
	enumerable: true
});

Stream.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Stream.className = "java.util.stream.Stream";
Stream.prototype.className = "java.util.stream.Stream";

// class property
Object.defineProperty(Stream, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.stream.Stream');
	},
	enumerable: true,
	configurable: false
});

// Cast
Stream.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Stream(Hyperloop.cast('java.util.stream.Stream', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function empty
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#empty()}
 **/
Stream.empty = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'empty',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#of(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#of(java.lang.Object[])}
 **/
Stream.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function builder
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#builder()}
 **/
Stream.builder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'builder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generate
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#generate(java.util.function.Supplier)}
 **/
Stream.generate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'generate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function iterate
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#iterate(java.lang.Object, java.util.function.UnaryOperator)}
 **/
Stream.iterate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'iterate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function concat
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#concat(java.util.stream.Stream, java.util.stream.Stream)}
 **/
Stream.concat = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'concat',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function distinct
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#distinct()}
 **/
Stream.prototype.distinct = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'distinct',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function skip
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#skip(long)}
 **/
Stream.prototype.skip = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'skip',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function findFirst
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#findFirst()}
 **/
Stream.prototype.findFirst = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findFirst',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function allMatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#allMatch(java.util.function.Predicate)}
 **/
Stream.prototype.allMatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allMatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flatMapToInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#flatMapToInt(java.util.function.Function)}
 **/
Stream.prototype.flatMapToInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flatMapToInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function min
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#min(java.util.Comparator)}
 **/
Stream.prototype.min = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'min',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flatMapToLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#flatMapToLong(java.util.function.Function)}
 **/
Stream.prototype.flatMapToLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flatMapToLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function mapToLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#mapToLong(java.util.function.ToLongFunction)}
 **/
Stream.prototype.mapToLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mapToLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function noneMatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#noneMatch(java.util.function.Predicate)}
 **/
Stream.prototype.noneMatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'noneMatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function findAny
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#findAny()}
 **/
Stream.prototype.findAny = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findAny',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function limit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#limit(long)}
 **/
Stream.prototype.limit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'limit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#toArray()}
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#toArray(java.util.function.IntFunction)}
 **/
Stream.prototype.toArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function forEachOrdered
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#forEachOrdered(java.util.function.Consumer)}
 **/
Stream.prototype.forEachOrdered = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEachOrdered',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function map
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#map(java.util.function.Function)}
 **/
Stream.prototype.map = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'map',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function anyMatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#anyMatch(java.util.function.Predicate)}
 **/
Stream.prototype.anyMatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'anyMatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function mapToDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#mapToDouble(java.util.function.ToDoubleFunction)}
 **/
Stream.prototype.mapToDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mapToDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function reduce
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#reduce(java.lang.Object, java.util.function.BinaryOperator)}
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#reduce(java.util.function.BinaryOperator)}
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#reduce(java.lang.Object, java.util.function.BiFunction, java.util.function.BinaryOperator)}
 **/
Stream.prototype.reduce = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reduce',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function max
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#max(java.util.Comparator)}
 **/
Stream.prototype.max = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'max',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function forEach
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#forEach(java.util.function.Consumer)}
 **/
Stream.prototype.forEach = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEach',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function count
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#count()}
 **/
Stream.prototype.count = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'count',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flatMapToDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#flatMapToDouble(java.util.function.Function)}
 **/
Stream.prototype.flatMapToDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flatMapToDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function peek
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#peek(java.util.function.Consumer)}
 **/
Stream.prototype.peek = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'peek',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function filter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#filter(java.util.function.Predicate)}
 **/
Stream.prototype.filter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'filter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flatMap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#flatMap(java.util.function.Function)}
 **/
Stream.prototype.flatMap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flatMap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function sorted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#sorted()}
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#sorted(java.util.Comparator)}
 **/
Stream.prototype.sorted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sorted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function mapToInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#mapToInt(java.util.function.ToIntFunction)}
 **/
Stream.prototype.mapToInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mapToInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function collect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#collect(java.util.function.Supplier, java.util.function.BiConsumer, java.util.function.BiConsumer)}
 * @see {@link http://developer.android.com/reference/java/util/stream/Stream.html#collect(java.util.stream.Collector)}
 **/
Stream.prototype.collect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'collect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.Stream') {
			return new Stream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Stream.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Stream.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Stream;
