/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module XmlPullParser
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.xmlpull.v1');

/**
 * constructor
 * http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html
 **/
var XmlPullParser = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'org.xmlpull.v1.XmlPullParser') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('org.xmlpull.v1.XmlPullParser');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
XmlPullParser.prototype = Object.create(SuperClass.prototype);
XmlPullParser.prototype.constructor = XmlPullParser;

Object.defineProperty(XmlPullParser.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new XmlPullParser(this.$native.super);
	},
	enumerable: true
});

XmlPullParser.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

XmlPullParser.className = "org.xmlpull.v1.XmlPullParser";
XmlPullParser.prototype.className = "org.xmlpull.v1.XmlPullParser";

// class property
Object.defineProperty(XmlPullParser, 'class', {
	get: function() {
		return Hyperloop.getClass('org.xmlpull.v1.XmlPullParser');
	},
	enumerable: true,
	configurable: false
});

// Cast
XmlPullParser.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new XmlPullParser(Hyperloop.cast('org.xmlpull.v1.XmlPullParser', object.$native));
};

// Constants
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#FEATURE_VALIDATION
XmlPullParser.FEATURE_VALIDATION = "http://xmlpull.org/v1/doc/features.html#validation";
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#DOCDECL
XmlPullParser.DOCDECL = 10;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#END_TAG
XmlPullParser.END_TAG = 3;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#END_DOCUMENT
XmlPullParser.END_DOCUMENT = 1;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#FEATURE_PROCESS_NAMESPACES
XmlPullParser.FEATURE_PROCESS_NAMESPACES = "http://xmlpull.org/v1/doc/features.html#process-namespaces";
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#TEXT
XmlPullParser.TEXT = 4;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#COMMENT
XmlPullParser.COMMENT = 9;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#FEATURE_REPORT_NAMESPACE_ATTRIBUTES
XmlPullParser.FEATURE_REPORT_NAMESPACE_ATTRIBUTES = "http://xmlpull.org/v1/doc/features.html#report-namespace-prefixes";
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#ENTITY_REF
XmlPullParser.ENTITY_REF = 6;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#FEATURE_PROCESS_DOCDECL
XmlPullParser.FEATURE_PROCESS_DOCDECL = "http://xmlpull.org/v1/doc/features.html#process-docdecl";
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#NO_NAMESPACE
XmlPullParser.NO_NAMESPACE = "";
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#PROCESSING_INSTRUCTION
XmlPullParser.PROCESSING_INSTRUCTION = 8;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#START_DOCUMENT
XmlPullParser.START_DOCUMENT = 0;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#IGNORABLE_WHITESPACE
XmlPullParser.IGNORABLE_WHITESPACE = 7;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#START_TAG
XmlPullParser.START_TAG = 2;
// http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#CDSECT
XmlPullParser.CDSECT = 5;

// Static methods

// Instance methods
/**
 * @function getAttributeType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributeType(int)}
 **/
XmlPullParser.prototype.getAttributeType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function next
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#next()}
 **/
XmlPullParser.prototype.next = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'next',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDepth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getDepth()}
 **/
XmlPullParser.prototype.getDepth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDepth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getName()}
 **/
XmlPullParser.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributeValue(int)}
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributeValue(java.lang.String, java.lang.String)}
 **/
XmlPullParser.prototype.getAttributeValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespaceCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getNamespaceCount(int)}
 **/
XmlPullParser.prototype.getNamespaceCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespaceCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTextCharacters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getTextCharacters(int[])}
 **/
XmlPullParser.prototype.getTextCharacters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextCharacters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#setFeature(java.lang.String, boolean)}
 **/
XmlPullParser.prototype.setFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespacePrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getNamespacePrefix(int)}
 **/
XmlPullParser.prototype.getNamespacePrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespacePrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPositionDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getPositionDescription()}
 **/
XmlPullParser.prototype.getPositionDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPositionDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isAttributeDefault
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#isAttributeDefault(int)}
 **/
XmlPullParser.prototype.isAttributeDefault = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAttributeDefault',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributePrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributePrefix(int)}
 **/
XmlPullParser.prototype.getAttributePrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributePrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getProperty(java.lang.String)}
 **/
XmlPullParser.prototype.getProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getPrefix()}
 **/
XmlPullParser.prototype.getPrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getText()}
 **/
XmlPullParser.prototype.getText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#nextText()}
 **/
XmlPullParser.prototype.nextText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function defineEntityReplacementText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#defineEntityReplacementText(java.lang.String, java.lang.String)}
 **/
XmlPullParser.prototype.defineEntityReplacementText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'defineEntityReplacementText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getColumnNumber
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getColumnNumber()}
 **/
XmlPullParser.prototype.getColumnNumber = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnNumber',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getInputEncoding
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getInputEncoding()}
 **/
XmlPullParser.prototype.getInputEncoding = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInputEncoding',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function require
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#require(int, java.lang.String, java.lang.String)}
 **/
XmlPullParser.prototype.require = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'require',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isWhitespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#isWhitespace()}
 **/
XmlPullParser.prototype.isWhitespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWhitespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributeCount()}
 **/
XmlPullParser.prototype.getAttributeCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributeName(int)}
 **/
XmlPullParser.prototype.getAttributeName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getFeature(java.lang.String)}
 **/
XmlPullParser.prototype.getFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setInput
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#setInput(java.io.Reader)}
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#setInput(java.io.InputStream, java.lang.String)}
 **/
XmlPullParser.prototype.setInput = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInput',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#nextTag()}
 **/
XmlPullParser.prototype.nextTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getLineNumber
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getLineNumber()}
 **/
XmlPullParser.prototype.getLineNumber = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLineNumber',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getEventType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getEventType()}
 **/
XmlPullParser.prototype.getEventType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isEmptyElementTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#isEmptyElementTag()}
 **/
XmlPullParser.prototype.isEmptyElementTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEmptyElementTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getNamespace(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getNamespace()}
 **/
XmlPullParser.prototype.getNamespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextToken
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#nextToken()}
 **/
XmlPullParser.prototype.nextToken = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextToken',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#setProperty(java.lang.String, java.lang.Object)}
 **/
XmlPullParser.prototype.setProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespaceUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getNamespaceUri(int)}
 **/
XmlPullParser.prototype.getNamespaceUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespaceUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeNamespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlPullParser.html#getAttributeNamespace(int)}
 **/
XmlPullParser.prototype.getAttributeNamespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeNamespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlPullParser') {
			return new XmlPullParser(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

XmlPullParser.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

XmlPullParser.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = XmlPullParser;
