/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module XmlSerializer
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.xmlpull.v1');

/**
 * constructor
 * http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html
 **/
var XmlSerializer = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'org.xmlpull.v1.XmlSerializer') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('org.xmlpull.v1.XmlSerializer');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
XmlSerializer.prototype = Object.create(SuperClass.prototype);
XmlSerializer.prototype.constructor = XmlSerializer;

Object.defineProperty(XmlSerializer.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new XmlSerializer(this.$native.super);
	},
	enumerable: true
});

XmlSerializer.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

XmlSerializer.className = "org.xmlpull.v1.XmlSerializer";
XmlSerializer.prototype.className = "org.xmlpull.v1.XmlSerializer";

// class property
Object.defineProperty(XmlSerializer, 'class', {
	get: function() {
		return Hyperloop.getClass('org.xmlpull.v1.XmlSerializer');
	},
	enumerable: true,
	configurable: false
});

// Cast
XmlSerializer.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new XmlSerializer(Hyperloop.cast('org.xmlpull.v1.XmlSerializer', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function cdsect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#cdsect(java.lang.String)}
 **/
XmlSerializer.prototype.cdsect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cdsect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#getProperty(java.lang.String)}
 **/
XmlSerializer.prototype.getProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#getPrefix(java.lang.String, boolean)}
 **/
XmlSerializer.prototype.getPrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDepth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#getDepth()}
 **/
XmlSerializer.prototype.getDepth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDepth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#getName()}
 **/
XmlSerializer.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function startTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#startTag(java.lang.String, java.lang.String)}
 **/
XmlSerializer.prototype.startTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function endTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#endTag(java.lang.String, java.lang.String)}
 **/
XmlSerializer.prototype.endTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'endTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function entityRef
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#entityRef(java.lang.String)}
 **/
XmlSerializer.prototype.entityRef = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'entityRef',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function startDocument
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#startDocument(java.lang.String, java.lang.Boolean)}
 **/
XmlSerializer.prototype.startDocument = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startDocument',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function endDocument
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#endDocument()}
 **/
XmlSerializer.prototype.endDocument = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'endDocument',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#getFeature(java.lang.String)}
 **/
XmlSerializer.prototype.getFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flush
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#flush()}
 **/
XmlSerializer.prototype.flush = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flush',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#setFeature(java.lang.String, boolean)}
 **/
XmlSerializer.prototype.setFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setPrefix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#setPrefix(java.lang.String, java.lang.String)}
 **/
XmlSerializer.prototype.setPrefix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPrefix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getNamespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#getNamespace()}
 **/
XmlSerializer.prototype.getNamespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNamespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#setProperty(java.lang.String, java.lang.Object)}
 **/
XmlSerializer.prototype.setProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function docdecl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#docdecl(java.lang.String)}
 **/
XmlSerializer.prototype.docdecl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'docdecl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function comment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#comment(java.lang.String)}
 **/
XmlSerializer.prototype.comment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'comment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function attribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#attribute(java.lang.String, java.lang.String, java.lang.String)}
 **/
XmlSerializer.prototype.attribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'attribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function text
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#text(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#text(char[], int, int)}
 **/
XmlSerializer.prototype.text = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'text',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function ignorableWhitespace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#ignorableWhitespace(java.lang.String)}
 **/
XmlSerializer.prototype.ignorableWhitespace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'ignorableWhitespace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setOutput
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#setOutput(java.io.OutputStream, java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#setOutput(java.io.Writer)}
 **/
XmlSerializer.prototype.setOutput = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOutput',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function processingInstruction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/xmlpull/v1/XmlSerializer.html#processingInstruction(java.lang.String)}
 **/
XmlSerializer.prototype.processingInstruction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'processingInstruction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.xmlpull.v1.XmlSerializer') {
			return new XmlSerializer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

XmlSerializer.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

XmlSerializer.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = XmlSerializer;
