/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.ColorSpace$Model
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.graphics.ColorSpace');

/**
 * @class android.graphics.ColorSpace$Model
 * @extends java.lang.Enum 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Model.html}
 **/
var Model = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.ColorSpace$Model')) {
		result = arguments[0];
	}
	else {
		result = Model.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Enum');
Model.prototype = Object.create(SuperClass.prototype);
Model.prototype.constructor = Model;

Object.defineProperty(Model.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Model(this.$native.super);
	},
	enumerable: true
});

Model.className = 'android.graphics.ColorSpace$Model';
Model.prototype.className = 'android.graphics.ColorSpace$Model';

// class property
Object.defineProperty(Model, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.ColorSpace$Model');
	},
	enumerable: true,
	configurable: false
});


// Cast
Model.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Model(Hyperloop.cast('android.graphics.ColorSpace$Model', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#CMYK
Object.defineProperty(Model, 'CMYK', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CMYK');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$Model') {
				return new Model(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#XYZ
Object.defineProperty(Model, 'XYZ', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('XYZ');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$Model') {
				return new Model(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#LAB
Object.defineProperty(Model, 'LAB', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('LAB');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$Model') {
				return new Model(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#RGB
Object.defineProperty(Model, 'RGB', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RGB');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.ColorSpace$Model') {
				return new Model(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#valueOf(java.lang.String)}
 **/
Model.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Model') {
			return new Model(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#values()}
 **/
Model.values = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'values',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Model') {
			return new Model(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getComponentCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Model.html#getComponentCount()}
 **/
Model.prototype.getComponentCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComponentCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Model') {
			return new Model(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Model;
