/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.ColorSpace$Rgb
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.graphics.ColorSpace');

/**
 * @class android.graphics.ColorSpace$Rgb
 * @extends android.graphics.ColorSpace 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html}
 **/
var Rgb = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.ColorSpace$Rgb')) {
		result = arguments[0];
	}
	else {
		result = Rgb.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.graphics.ColorSpace');
Rgb.prototype = Object.create(SuperClass.prototype);
Rgb.prototype.constructor = Rgb;

Object.defineProperty(Rgb.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Rgb(this.$native.super);
	},
	enumerable: true
});

Rgb.className = 'android.graphics.ColorSpace$Rgb';
Rgb.prototype.className = 'android.graphics.ColorSpace$Rgb';

// class property
Object.defineProperty(Rgb, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.ColorSpace$Rgb');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Rgb.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.graphics.ColorSpace$Rgb');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Rgb.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Rgb.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Rgb(Hyperloop.cast('android.graphics.ColorSpace$Rgb', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getMaxValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getMaxValue(int)}
 **/
Rgb.prototype.getMaxValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaxValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLinear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#toLinear(float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#toLinear(float[])}
 **/
Rgb.prototype.toLinear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLinear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toXyz
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#toXyz(float[])}
 **/
Rgb.prototype.toXyz = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toXyz',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWhitePoint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getWhitePoint(float[])}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getWhitePoint()}
 **/
Rgb.prototype.getWhitePoint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWhitePoint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSrgb
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#isSrgb()}
 **/
Rgb.prototype.isSrgb = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSrgb',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEotf
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getEotf()}
 **/
Rgb.prototype.getEotf = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEotf',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInverseTransform
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getInverseTransform(float[])}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getInverseTransform()}
 **/
Rgb.prototype.getInverseTransform = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInverseTransform',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isWideGamut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#isWideGamut()}
 **/
Rgb.prototype.isWideGamut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWideGamut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getMinValue(int)}
 **/
Rgb.prototype.getMinValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPrimaries
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getPrimaries(float[])}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getPrimaries()}
 **/
Rgb.prototype.getPrimaries = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPrimaries',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#hashCode()}
 **/
Rgb.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#equals(java.lang.Object)}
 **/
Rgb.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fromXyz
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#fromXyz(float[])}
 **/
Rgb.prototype.fromXyz = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fromXyz',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTransform
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getTransform(float[])}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getTransform()}
 **/
Rgb.prototype.getTransform = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTransform',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOetf
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getOetf()}
 **/
Rgb.prototype.getOetf = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOetf',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTransferParameters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#getTransferParameters()}
 **/
Rgb.prototype.getTransferParameters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTransferParameters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fromLinear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#fromLinear(float, float, float)}
 * @see {@link http://developer.android.com/reference/android/graphics/ColorSpace.Rgb.html#fromLinear(float[])}
 **/
Rgb.prototype.fromLinear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fromLinear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.ColorSpace$Rgb') {
			return new Rgb(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Rgb;
