/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.os.VibrationEffect
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.os');

/**
 * @class android.os.VibrationEffect
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.html}
 **/
var VibrationEffect = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.os.VibrationEffect')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.os.VibrationEffect. Create a subclass using android.os.VibrationEffect.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
VibrationEffect.prototype = Object.create(SuperClass.prototype);
VibrationEffect.prototype.constructor = VibrationEffect;

Object.defineProperty(VibrationEffect.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new VibrationEffect(this.$native.super);
	},
	enumerable: true
});

VibrationEffect.className = 'android.os.VibrationEffect';
VibrationEffect.prototype.className = 'android.os.VibrationEffect';

// class property
Object.defineProperty(VibrationEffect, 'class', {
	get: function() {
		return Hyperloop.getClass('android.os.VibrationEffect');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
VibrationEffect.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.os.VibrationEffect');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(VibrationEffect.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
VibrationEffect.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new VibrationEffect(Hyperloop.cast('android.os.VibrationEffect', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.html#DEFAULT_AMPLITUDE}
 */
VibrationEffect.DEFAULT_AMPLITUDE = -1;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/os/VibrationEffect.html#CREATOR
Object.defineProperty(VibrationEffect, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.os.VibrationEffect') {
				return new VibrationEffect(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function createOneShot
 * @static
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.html#createOneShot(long, int)}
 **/
VibrationEffect.createOneShot = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createOneShot',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.VibrationEffect') {
			return new VibrationEffect(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWaveform
 * @static
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.html#createWaveform(long[], int)}
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.html#createWaveform(long[], int[], int)}
 **/
VibrationEffect.createWaveform = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWaveform',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.VibrationEffect') {
			return new VibrationEffect(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.html#describeContents()}
 **/
VibrationEffect.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.VibrationEffect') {
			return new VibrationEffect(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = VibrationEffect;
