/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module AttributeSet
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.util');

/**
 * constructor
 * http://developer.android.com/reference/android/util/AttributeSet.html
 **/
var AttributeSet = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.util.AttributeSet') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.util.AttributeSet');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
AttributeSet.prototype = Object.create(SuperClass.prototype);
AttributeSet.prototype.constructor = AttributeSet;

Object.defineProperty(AttributeSet.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AttributeSet(this.$native.super);
	},
	enumerable: true
});

AttributeSet.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

AttributeSet.className = "android.util.AttributeSet";
AttributeSet.prototype.className = "android.util.AttributeSet";

// class property
Object.defineProperty(AttributeSet, 'class', {
	get: function() {
		return Hyperloop.getClass('android.util.AttributeSet');
	},
	enumerable: true,
	configurable: false
});

// Cast
AttributeSet.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AttributeSet(Hyperloop.cast('android.util.AttributeSet', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function getAttributeValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeValue(int)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeValue(java.lang.String, java.lang.String)}
 **/
AttributeSet.prototype.getAttributeValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeListValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeListValue(java.lang.String, java.lang.String, java.lang.String[], int)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeListValue(int, java.lang.String[], int)}
 **/
AttributeSet.prototype.getAttributeListValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeListValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIdAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getIdAttribute()}
 **/
AttributeSet.prototype.getIdAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIdAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeCount()}
 **/
AttributeSet.prototype.getAttributeCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeName(int)}
 **/
AttributeSet.prototype.getAttributeName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeIntValue(java.lang.String, java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeIntValue(int, int)}
 **/
AttributeSet.prototype.getAttributeIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeFloatValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeFloatValue(java.lang.String, java.lang.String, float)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeFloatValue(int, float)}
 **/
AttributeSet.prototype.getAttributeFloatValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeFloatValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIdAttributeResourceValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getIdAttributeResourceValue(int)}
 **/
AttributeSet.prototype.getIdAttributeResourceValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIdAttributeResourceValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeNameResource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeNameResource(int)}
 **/
AttributeSet.prototype.getAttributeNameResource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeNameResource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeResourceValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeResourceValue(java.lang.String, java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeResourceValue(int, int)}
 **/
AttributeSet.prototype.getAttributeResourceValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeResourceValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeBooleanValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeBooleanValue(java.lang.String, java.lang.String, boolean)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeBooleanValue(int, boolean)}
 **/
AttributeSet.prototype.getAttributeBooleanValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeBooleanValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttributeUnsignedIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeUnsignedIntValue(java.lang.String, java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getAttributeUnsignedIntValue(int, int)}
 **/
AttributeSet.prototype.getAttributeUnsignedIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributeUnsignedIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPositionDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getPositionDescription()}
 **/
AttributeSet.prototype.getPositionDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPositionDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getClassAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getClassAttribute()}
 **/
AttributeSet.prototype.getClassAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClassAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getStyleAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/util/AttributeSet.html#getStyleAttribute()}
 **/
AttributeSet.prototype.getStyleAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStyleAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.util.AttributeSet') {
			return new AttributeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

AttributeSet.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

AttributeSet.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = AttributeSet;
