/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.Display$HdrCapabilities
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.view.Display');

/**
 * @class android.view.Display$HdrCapabilities
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html}
 **/
var HdrCapabilities = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.Display$HdrCapabilities')) {
		result = arguments[0];
	}
	else {
		result = HdrCapabilities.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
HdrCapabilities.prototype = Object.create(SuperClass.prototype);
HdrCapabilities.prototype.constructor = HdrCapabilities;

Object.defineProperty(HdrCapabilities.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new HdrCapabilities(this.$native.super);
	},
	enumerable: true
});

HdrCapabilities.className = 'android.view.Display$HdrCapabilities';
HdrCapabilities.prototype.className = 'android.view.Display$HdrCapabilities';

// class property
Object.defineProperty(HdrCapabilities, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.Display$HdrCapabilities');
	},
	enumerable: true,
	configurable: false
});


// Cast
HdrCapabilities.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new HdrCapabilities(Hyperloop.cast('android.view.Display$HdrCapabilities', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#HDR_TYPE_DOLBY_VISION}
 */
HdrCapabilities.HDR_TYPE_DOLBY_VISION = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#INVALID_LUMINANCE}
 */
HdrCapabilities.INVALID_LUMINANCE = -1.0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#HDR_TYPE_HLG}
 */
HdrCapabilities.HDR_TYPE_HLG = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#HDR_TYPE_HDR10}
 */
HdrCapabilities.HDR_TYPE_HDR10 = 2;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#CREATOR
Object.defineProperty(HdrCapabilities, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.Display$HdrCapabilities') {
				return new HdrCapabilities(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSupportedHdrTypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#getSupportedHdrTypes()}
 **/
HdrCapabilities.prototype.getSupportedHdrTypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportedHdrTypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDesiredMinLuminance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#getDesiredMinLuminance()}
 **/
HdrCapabilities.prototype.getDesiredMinLuminance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDesiredMinLuminance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDesiredMaxAverageLuminance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#getDesiredMaxAverageLuminance()}
 **/
HdrCapabilities.prototype.getDesiredMaxAverageLuminance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDesiredMaxAverageLuminance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#hashCode()}
 **/
HdrCapabilities.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#equals(java.lang.Object)}
 **/
HdrCapabilities.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDesiredMaxLuminance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#getDesiredMaxLuminance()}
 **/
HdrCapabilities.prototype.getDesiredMaxLuminance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDesiredMaxLuminance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#writeToParcel(android.os.Parcel, int)}
 **/
HdrCapabilities.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/Display.HdrCapabilities.html#describeContents()}
 **/
HdrCapabilities.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.Display$HdrCapabilities') {
			return new HdrCapabilities(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = HdrCapabilities;
