/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.FrameMetrics
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.FrameMetrics
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html}
 **/
var FrameMetrics = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.FrameMetrics')) {
		result = arguments[0];
	}
	else {
		result = FrameMetrics.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FrameMetrics.prototype = Object.create(SuperClass.prototype);
FrameMetrics.prototype.constructor = FrameMetrics;

Object.defineProperty(FrameMetrics.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FrameMetrics(this.$native.super);
	},
	enumerable: true
});

FrameMetrics.className = 'android.view.FrameMetrics';
FrameMetrics.prototype.className = 'android.view.FrameMetrics';

// class property
Object.defineProperty(FrameMetrics, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.FrameMetrics');
	},
	enumerable: true,
	configurable: false
});


// Cast
FrameMetrics.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FrameMetrics(Hyperloop.cast('android.view.FrameMetrics', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#VSYNC_TIMESTAMP}
 */
FrameMetrics.VSYNC_TIMESTAMP = 11;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#INTENDED_VSYNC_TIMESTAMP}
 */
FrameMetrics.INTENDED_VSYNC_TIMESTAMP = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#TOTAL_DURATION}
 */
FrameMetrics.TOTAL_DURATION = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#ANIMATION_DURATION}
 */
FrameMetrics.ANIMATION_DURATION = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#DRAW_DURATION}
 */
FrameMetrics.DRAW_DURATION = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#FIRST_DRAW_FRAME}
 */
FrameMetrics.FIRST_DRAW_FRAME = 9;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#SWAP_BUFFERS_DURATION}
 */
FrameMetrics.SWAP_BUFFERS_DURATION = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#UNKNOWN_DELAY_DURATION}
 */
FrameMetrics.UNKNOWN_DELAY_DURATION = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#LAYOUT_MEASURE_DURATION}
 */
FrameMetrics.LAYOUT_MEASURE_DURATION = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#COMMAND_ISSUE_DURATION}
 */
FrameMetrics.COMMAND_ISSUE_DURATION = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#INPUT_HANDLING_DURATION}
 */
FrameMetrics.INPUT_HANDLING_DURATION = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#SYNC_DURATION}
 */
FrameMetrics.SYNC_DURATION = 5;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getMetric
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/FrameMetrics.html#getMetric(int)}
 **/
FrameMetrics.prototype.getMetric = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMetric',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.FrameMetrics') {
			return new FrameMetrics(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FrameMetrics;
