/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module SubMenu
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * constructor
 * http://developer.android.com/reference/android/view/SubMenu.html
 **/
var SubMenu = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.view.SubMenu') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.view.SubMenu');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
SubMenu.prototype = Object.create(SuperClass.prototype);
SubMenu.prototype.constructor = SubMenu;

Object.defineProperty(SubMenu.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SubMenu(this.$native.super);
	},
	enumerable: true
});

SubMenu.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

SubMenu.className = "android.view.SubMenu";
SubMenu.prototype.className = "android.view.SubMenu";

// class property
Object.defineProperty(SubMenu, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.SubMenu');
	},
	enumerable: true,
	configurable: false
});

// Cast
SubMenu.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SubMenu(Hyperloop.cast('android.view.SubMenu', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function add
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#add(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#add(int)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#add(int, int, int, java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#add(int, int, int, int)}
 **/
SubMenu.prototype.add = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'add',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function removeItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#removeItem(int)}
 **/
SubMenu.prototype.removeItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setQwertyMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setQwertyMode(boolean)}
 **/
SubMenu.prototype.setQwertyMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setQwertyMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function clearHeader
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#clearHeader()}
 **/
SubMenu.prototype.clearHeader = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clearHeader',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function addSubMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#addSubMenu(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#addSubMenu(int)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#addSubMenu(int, int, int, java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#addSubMenu(int, int, int, int)}
 **/
SubMenu.prototype.addSubMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addSubMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function performIdentifierAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#performIdentifierAction(int, int)}
 **/
SubMenu.prototype.performIdentifierAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performIdentifierAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function clear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#clear()}
 **/
SubMenu.prototype.clear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#getItem()}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#getItem(int)}
 **/
SubMenu.prototype.getItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setGroupVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setGroupVisible(int, boolean)}
 **/
SubMenu.prototype.setGroupVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGroupVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isShortcutKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#isShortcutKey(int, android.view.KeyEvent)}
 **/
SubMenu.prototype.isShortcutKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isShortcutKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setGroupCheckable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setGroupCheckable(int, boolean, boolean)}
 **/
SubMenu.prototype.setGroupCheckable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGroupCheckable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setHeaderView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setHeaderView(android.view.View)}
 **/
SubMenu.prototype.setHeaderView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeaderView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setIcon(int)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setIcon(android.graphics.drawable.Drawable)}
 **/
SubMenu.prototype.setIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setGroupEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setGroupEnabled(int, boolean)}
 **/
SubMenu.prototype.setGroupEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGroupEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hasVisibleItems
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#hasVisibleItems()}
 **/
SubMenu.prototype.hasVisibleItems = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasVisibleItems',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function findItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#findItem(int)}
 **/
SubMenu.prototype.findItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function size
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#size()}
 **/
SubMenu.prototype.size = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'size',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setHeaderIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setHeaderIcon(int)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setHeaderIcon(android.graphics.drawable.Drawable)}
 **/
SubMenu.prototype.setHeaderIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeaderIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function removeGroup
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#removeGroup(int)}
 **/
SubMenu.prototype.removeGroup = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeGroup',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function performShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#performShortcut(int, android.view.KeyEvent, int)}
 **/
SubMenu.prototype.performShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function addIntentOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#addIntentOptions(int, int, int, android.content.ComponentName, android.content.Intent[], android.content.Intent, int, android.view.MenuItem[])}
 **/
SubMenu.prototype.addIntentOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addIntentOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setHeaderTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setHeaderTitle(int)}
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#setHeaderTitle(java.lang.CharSequence)}
 **/
SubMenu.prototype.setHeaderTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeaderTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SubMenu.html#close()}
 **/
SubMenu.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SubMenu') {
			return new SubMenu(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

SubMenu.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

SubMenu.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = SubMenu;
