/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.animation.AccelerateDecelerateInterpolator
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.animation');

/**
 * @class android.view.animation.AccelerateDecelerateInterpolator
 * @extends android.view.animation.BaseInterpolator 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/animation/AccelerateDecelerateInterpolator.html}
 **/
var AccelerateDecelerateInterpolator = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.animation.AccelerateDecelerateInterpolator')) {
		result = arguments[0];
	}
	else {
		result = AccelerateDecelerateInterpolator.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.animation.BaseInterpolator');
AccelerateDecelerateInterpolator.prototype = Object.create(SuperClass.prototype);
AccelerateDecelerateInterpolator.prototype.constructor = AccelerateDecelerateInterpolator;

Object.defineProperty(AccelerateDecelerateInterpolator.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccelerateDecelerateInterpolator(this.$native.super);
	},
	enumerable: true
});

AccelerateDecelerateInterpolator.className = 'android.view.animation.AccelerateDecelerateInterpolator';
AccelerateDecelerateInterpolator.prototype.className = 'android.view.animation.AccelerateDecelerateInterpolator';

// class property
Object.defineProperty(AccelerateDecelerateInterpolator, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.animation.AccelerateDecelerateInterpolator');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AccelerateDecelerateInterpolator.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.animation.AccelerateDecelerateInterpolator');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AccelerateDecelerateInterpolator.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AccelerateDecelerateInterpolator.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccelerateDecelerateInterpolator(Hyperloop.cast('android.view.animation.AccelerateDecelerateInterpolator', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getInterpolation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/animation/AccelerateDecelerateInterpolator.html#getInterpolation(float)}
 **/
AccelerateDecelerateInterpolator.prototype.getInterpolation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterpolation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.animation.AccelerateDecelerateInterpolator') {
			return new AccelerateDecelerateInterpolator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccelerateDecelerateInterpolator;
