/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.lang.Throwable
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.lang');

/**
 * @class java.lang.Throwable
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html}
 **/
var Throwable = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.lang.Throwable')) {
		result = arguments[0];
	}
	else {
		result = Throwable.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Throwable.prototype = Object.create(SuperClass.prototype);
Throwable.prototype.constructor = Throwable;

Object.defineProperty(Throwable.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Throwable(this.$native.super);
	},
	enumerable: true
});

Throwable.className = 'java.lang.Throwable';
Throwable.prototype.className = 'java.lang.Throwable';

// class property
Object.defineProperty(Throwable, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.Throwable');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Throwable.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.lang.Throwable');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Throwable.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Throwable.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Throwable(Hyperloop.cast('java.lang.Throwable', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(Throwable, 'SentinelHolder', {
	get: function() {
		return require('./java.lang.Throwable$SentinelHolder');
	},
	enumerable: true
});
Object.defineProperty(Throwable, 'WrappedPrintWriter', {
	get: function() {
		return require('./java.lang.Throwable$WrappedPrintWriter');
	},
	enumerable: true
});
Object.defineProperty(Throwable, 'WrappedPrintStream', {
	get: function() {
		return require('./java.lang.Throwable$WrappedPrintStream');
	},
	enumerable: true
});
Object.defineProperty(Throwable, 'PrintStreamOrWriter', {
	get: function() {
		return require('./java.lang.Throwable$PrintStreamOrWriter');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function printStackTrace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#printStackTrace()}
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#printStackTrace(java.io.PrintStream)}
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#printStackTrace(java.io.PrintWriter)}
 **/
Throwable.prototype.printStackTrace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'printStackTrace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStackTrace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#getStackTrace()}
 **/
Throwable.prototype.getStackTrace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStackTrace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setStackTrace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#setStackTrace(java.lang.StackTraceElement[])}
 **/
Throwable.prototype.setStackTrace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setStackTrace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addSuppressed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#addSuppressed(java.lang.Throwable)}
 **/
Throwable.prototype.addSuppressed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addSuppressed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLocalizedMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#getLocalizedMessage()}
 **/
Throwable.prototype.getLocalizedMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocalizedMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function initCause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#initCause(java.lang.Throwable)}
 **/
Throwable.prototype.initCause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initCause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#getMessage()}
 **/
Throwable.prototype.getMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#toString()}
 **/
Throwable.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSuppressed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#getSuppressed()}
 **/
Throwable.prototype.getSuppressed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSuppressed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#getCause()}
 **/
Throwable.prototype.getCause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fillInStackTrace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/Throwable.html#fillInStackTrace()}
 **/
Throwable.prototype.fillInStackTrace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fillInStackTrace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.Throwable') {
			return new Throwable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Throwable;
