/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.HashMap$EntrySpliterator
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./java.util.HashMap');

/**
 * @class java.util.HashMap$EntrySpliterator
 * @extends java.util.HashMap.HashMapSpliterator 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/HashMap.EntrySpliterator.html}
 **/
var EntrySpliterator = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.HashMap$EntrySpliterator')) {
		result = arguments[0];
	}
	else {
		result = EntrySpliterator.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.util.HashMap$HashMapSpliterator');
EntrySpliterator.prototype = Object.create(SuperClass.prototype);
EntrySpliterator.prototype.constructor = EntrySpliterator;

Object.defineProperty(EntrySpliterator.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new EntrySpliterator(this.$native.super);
	},
	enumerable: true
});

EntrySpliterator.className = 'java.util.HashMap$EntrySpliterator';
EntrySpliterator.prototype.className = 'java.util.HashMap$EntrySpliterator';

// class property
Object.defineProperty(EntrySpliterator, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.HashMap$EntrySpliterator');
	},
	enumerable: true,
	configurable: false
});


// Cast
EntrySpliterator.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new EntrySpliterator(Hyperloop.cast('java.util.HashMap$EntrySpliterator', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function trySplit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.EntrySpliterator.html#trySplit()}
 * @see {@link http://developer.android.com/reference/java/util/HashMap.EntrySpliterator.html#trySplit()}
 **/
EntrySpliterator.prototype.trySplit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'trySplit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap$EntrySpliterator') {
			return new EntrySpliterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function tryAdvance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.EntrySpliterator.html#tryAdvance(java.util.function.Consumer)}
 **/
EntrySpliterator.prototype.tryAdvance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'tryAdvance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap$EntrySpliterator') {
			return new EntrySpliterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function characteristics
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.EntrySpliterator.html#characteristics()}
 **/
EntrySpliterator.prototype.characteristics = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'characteristics',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap$EntrySpliterator') {
			return new EntrySpliterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forEachRemaining
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/HashMap.EntrySpliterator.html#forEachRemaining(java.util.function.Consumer)}
 **/
EntrySpliterator.prototype.forEachRemaining = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEachRemaining',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.HashMap$EntrySpliterator') {
			return new EntrySpliterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = EntrySpliterator;
