/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module OfPrimitive
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./java.util.Spliterator');

/**
 * constructor
 * http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html
 **/
var OfPrimitive = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.Spliterator$OfPrimitive') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.Spliterator$OfPrimitive');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
OfPrimitive.prototype = Object.create(SuperClass.prototype);
OfPrimitive.prototype.constructor = OfPrimitive;

Object.defineProperty(OfPrimitive.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new OfPrimitive(this.$native.super);
	},
	enumerable: true
});

OfPrimitive.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

OfPrimitive.className = "java.util.Spliterator$OfPrimitive";
OfPrimitive.prototype.className = "java.util.Spliterator$OfPrimitive";

// class property
Object.defineProperty(OfPrimitive, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.Spliterator$OfPrimitive');
	},
	enumerable: true,
	configurable: false
});

// Cast
OfPrimitive.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new OfPrimitive(Hyperloop.cast('java.util.Spliterator$OfPrimitive', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function trySplit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#trySplit()}
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#trySplit()}
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#trySplit()}
 **/
OfPrimitive.prototype.trySplit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'trySplit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function tryAdvance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#tryAdvance(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#tryAdvance(java.util.function.Consumer)}
 **/
OfPrimitive.prototype.tryAdvance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'tryAdvance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function characteristics
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#characteristics()}
 **/
OfPrimitive.prototype.characteristics = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'characteristics',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getComparator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#getComparator()}
 **/
OfPrimitive.prototype.getComparator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComparator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function estimateSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#estimateSize()}
 **/
OfPrimitive.prototype.estimateSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'estimateSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getExactSizeIfKnown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#getExactSizeIfKnown()}
 **/
OfPrimitive.prototype.getExactSizeIfKnown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExactSizeIfKnown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function forEachRemaining
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#forEachRemaining(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#forEachRemaining(java.util.function.Consumer)}
 **/
OfPrimitive.prototype.forEachRemaining = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEachRemaining',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hasCharacteristics
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Spliterator.OfPrimitive.html#hasCharacteristics(int)}
 **/
OfPrimitive.prototype.hasCharacteristics = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasCharacteristics',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Spliterator$OfPrimitive') {
			return new OfPrimitive(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

OfPrimitive.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

OfPrimitive.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = OfPrimitive;
