/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module DoubleStream
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.stream');

/**
 * constructor
 * http://developer.android.com/reference/java/util/stream/DoubleStream.html
 **/
var DoubleStream = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.stream.DoubleStream') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.stream.DoubleStream');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
DoubleStream.prototype = Object.create(SuperClass.prototype);
DoubleStream.prototype.constructor = DoubleStream;

Object.defineProperty(DoubleStream.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DoubleStream(this.$native.super);
	},
	enumerable: true
});

DoubleStream.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

DoubleStream.className = "java.util.stream.DoubleStream";
DoubleStream.prototype.className = "java.util.stream.DoubleStream";

// class property
Object.defineProperty(DoubleStream, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.stream.DoubleStream');
	},
	enumerable: true,
	configurable: false
});

// Cast
DoubleStream.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DoubleStream(Hyperloop.cast('java.util.stream.DoubleStream', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function empty
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#empty()}
 **/
DoubleStream.empty = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'empty',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#of(double)}
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#of(double[])}
 **/
DoubleStream.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function builder
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#builder()}
 **/
DoubleStream.builder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'builder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generate
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#generate(java.util.function.DoubleSupplier)}
 **/
DoubleStream.generate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'generate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function iterate
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#iterate(double, java.util.function.DoubleUnaryOperator)}
 **/
DoubleStream.iterate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'iterate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function concat
 * @static
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#concat(java.util.stream.DoubleStream, java.util.stream.DoubleStream)}
 **/
DoubleStream.concat = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'concat',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function average
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#average()}
 **/
DoubleStream.prototype.average = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'average',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function sequential
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#sequential()}
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#sequential()}
 **/
DoubleStream.prototype.sequential = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sequential',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function distinct
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#distinct()}
 **/
DoubleStream.prototype.distinct = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'distinct',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function skip
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#skip(long)}
 **/
DoubleStream.prototype.skip = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'skip',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function sum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#sum()}
 **/
DoubleStream.prototype.sum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function findFirst
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#findFirst()}
 **/
DoubleStream.prototype.findFirst = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findFirst',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function allMatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#allMatch(java.util.function.DoublePredicate)}
 **/
DoubleStream.prototype.allMatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allMatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function mapToObj
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#mapToObj(java.util.function.DoubleFunction)}
 **/
DoubleStream.prototype.mapToObj = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mapToObj',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function iterator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#iterator()}
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#iterator()}
 **/
DoubleStream.prototype.iterator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'iterator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function min
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#min()}
 **/
DoubleStream.prototype.min = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'min',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function mapToLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#mapToLong(java.util.function.DoubleToLongFunction)}
 **/
DoubleStream.prototype.mapToLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mapToLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function parallel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#parallel()}
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#parallel()}
 **/
DoubleStream.prototype.parallel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parallel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function noneMatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#noneMatch(java.util.function.DoublePredicate)}
 **/
DoubleStream.prototype.noneMatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'noneMatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function findAny
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#findAny()}
 **/
DoubleStream.prototype.findAny = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findAny',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function limit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#limit(long)}
 **/
DoubleStream.prototype.limit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'limit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#toArray()}
 **/
DoubleStream.prototype.toArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function forEachOrdered
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#forEachOrdered(java.util.function.DoubleConsumer)}
 **/
DoubleStream.prototype.forEachOrdered = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEachOrdered',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function map
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#map(java.util.function.DoubleUnaryOperator)}
 **/
DoubleStream.prototype.map = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'map',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function anyMatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#anyMatch(java.util.function.DoublePredicate)}
 **/
DoubleStream.prototype.anyMatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'anyMatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function reduce
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#reduce(double, java.util.function.DoubleBinaryOperator)}
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#reduce(java.util.function.DoubleBinaryOperator)}
 **/
DoubleStream.prototype.reduce = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reduce',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function max
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#max()}
 **/
DoubleStream.prototype.max = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'max',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function spliterator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#spliterator()}
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#spliterator()}
 **/
DoubleStream.prototype.spliterator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'spliterator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function forEach
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#forEach(java.util.function.DoubleConsumer)}
 **/
DoubleStream.prototype.forEach = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forEach',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function count
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#count()}
 **/
DoubleStream.prototype.count = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'count',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function peek
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#peek(java.util.function.DoubleConsumer)}
 **/
DoubleStream.prototype.peek = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'peek',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function filter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#filter(java.util.function.DoublePredicate)}
 **/
DoubleStream.prototype.filter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'filter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flatMap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#flatMap(java.util.function.DoubleFunction)}
 **/
DoubleStream.prototype.flatMap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flatMap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function sorted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#sorted()}
 **/
DoubleStream.prototype.sorted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sorted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function boxed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#boxed()}
 **/
DoubleStream.prototype.boxed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'boxed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function summaryStatistics
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#summaryStatistics()}
 **/
DoubleStream.prototype.summaryStatistics = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'summaryStatistics',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function mapToInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#mapToInt(java.util.function.DoubleToIntFunction)}
 **/
DoubleStream.prototype.mapToInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mapToInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function collect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/stream/DoubleStream.html#collect(java.util.function.Supplier, java.util.function.ObjDoubleConsumer, java.util.function.BiConsumer)}
 **/
DoubleStream.prototype.collect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'collect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.stream.DoubleStream') {
			return new DoubleStream(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

DoubleStream.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

DoubleStream.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = DoubleStream;
